<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');
// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
Yii::setPathOfAlias('bootstrap', dirname(__FILE__) . '/../extensions/bootstrap');
Yii::setPathOfAlias('editable', dirname(__FILE__) . '/../extensions/editable');
//Yii::setPathOfAlias('PhpOffice', dirname(__FILE__) . '/../extensions/Spreadsheet');
return array(
    'basePath' => dirname(__FILE__) . DIRECTORY_SEPARATOR . '..',
    'name' => 'Cumulus ERP',
    // preloading 'log' component
    'preload' => array('log'),
    // autoloading model and component classes
    'import' => array(
         'application.extensions.*',
        'application.models.*',
        'editable.*',
        'application.components.*',
        'application.extensions.yii-mail.YiiMailMessage',
        // Add Spreadsheet autoload here
       // 'application.extensions.Spreadsheet.autoload', 
       // 'application.extensions.CJuiDateTimePicker.CJuiDateTimePicker'
    ),
    'modules' => array(
        // uncomment the following to enable the Gii tool

        'gii' => array(
            'class' => 'system.gii.GiiModule',
            'password' => '@yamaha',
            // If removed, Gii defaults to localhost only. Edit carefully to taste.
            'ipFilters' => array('*'),
        ),
    ),
    // application components
    'components' => array(
        'clientScript' => array(
            //'class' => 'application.extensions.CClientScriptMinify',
            //'minifyController' => '/minify',
            'packages' => array(
                'jquery' => array(
                    'baseUrl' => '',
                    'js' => array('js/jquery-2.1.4.js'),
                    'coreScriptPosition' => CClientScript::POS_HEAD
                ),
                'jquery.ui' => array(
                    'baseUrl' => '',
                    'js' => array('js/jquery-ui.min.js'),
                    'depends' => array('jquery'),
                    'coreScriptPosition' => CClientScript::POS_END
                ),
            ),
        ),
        'ePdf' => array(
            'class' => 'ext.yii-pdf.EYiiPdf',
            'params' => array(
                'mpdf' => array(
                    'librarySourcePath' => 'application.vendors.mpdf.*',
                    'constants' => array(
                        '_MPDF_TEMP_PATH' => Yii::getPathOfAlias('application.runtime'),
                    ),
                    'class' => 'mpdf', // the literal class filename to be loaded from the vendors folder
                ),
            ),
        ),
        'session' => array(
            'autoStart' => true,
        ),
        'phpThumb' => array(
            'class' => 'ext.EPhpThumb.EPhpThumb',
        //'options'=>array(optional phpThumb specific options are added here)
        ),
        'Spreadsheet' => array(
            'class' => 'ext.PhpOffice.PhpSpreadsheet.Spreadsheet',
        //'options'=>array(optional phpThumb specific options are added here)
        ),
        'dateTimePicker' => array(
            'class' => 'ext.CJuiDateTimePicker.CJuiDateTimePicker'
        ),
        'timePicker' => array(
            'class' => 'ext.timepicker.timepicker'
        ),
        'mail' => array(
            'class' => 'application.extensions.yii-mail.YiiMail',
            'transportType' => 'php',
            'transportOptions' => array(
               
                'host' => 'smtp.gmail.com',
                'username' => 'info@blueskyerp.me',
                'password' => 'Cumulus+D4&',
                'port' => 587,
           
            ),
            'viewPath' => 'application.views.mail',
            'logging' => true,
            'dryRun' => false
        ),
        'user' => array(
            'class' => 'application.components.EWebUser',
            'loginRequiredAjaxResponse' => 'YII_LOGIN_REQUIRED',
            // enable cookie-based authentication
            'allowAutoLogin' => true,
        ),
        // uncomment the following to enable URLs in path-format
        /* 'urlManager' => array(
          'urlFormat' => 'path',
          'showScriptName' => false,
          'caseSensitive' => false,
          'rules' => array(
          '<controller:\w+>/<id:\d+>' => '<controller>/view',
          '<controller:\w+>/<action:\w+>/<id:\d+>' => '<controller>/<action>',
          '<controller:\w+>/<action:\w+>' => '<controller>/<action>',
          ),
          ), */
        /* 'db'=>array(
          'connectionString' => 'sqlite:'.dirname(__FILE__).'/../data/testdrive.db',
          ), */


        // uncomment the following to use a MySQL database
        /*'db' => array(
            'connectionString' => 'mysql:host=ymgflogistics.mysql.database.azure.com;dbname=yamaha',
            'emulatePrepare' => true,
            'username' => 'admin_ymgf@ymgflogistics',
            'password' => 'Azure@20$20%a#',
            'charset' => 'utf8',
            'tablePrefix' => 'nia_',
        ),*/
        
         'db' => array(
            'connectionString' => 'mysql:host=localhost;dbname=blskysoftware_yamaha',//bluelogi_yamaha_new_1
            'emulatePrepare' => true,
            'username' => 'blskysoftware_yamaha',
            'password' => '#%R#&BeNNIDB',
            'charset' => 'utf8',
            'tablePrefix' => 'ymh_',
        ),

        'errorHandler' => array(
            // use 'site/error' action to display errors
            'errorAction' => 'site/error',
        ),
        'log' => array(
            'class' => 'CLogRouter',
            'routes' => array(
                array(
                    'class' => 'CFileLogRoute',
                    'levels' => 'error, warning',
                ),
            // uncomment the following to show log messages on web pages
            /* array(
              'class' => 'CWebLogRoute',
              ), */
            ),
        ),
        //X-editable config
        'editable' => array(
            'class' => 'editable.EditableConfig',
            'form' => 'bootstrap', //form style: 'bootstrap', 'jqueryui', 'plain' 
            'mode' => 'popup', //mode: 'popup' or 'inline'  
            'defaults' => array(//default settings for all editable elements
                'emptytext' => 'Click to edit'
            )
        ),
        'bootstrap' => array(
            'class' => 'bootstrap.components.Bootstrap',
        ),
        'request' => array(
           //'class' => 'application.components.HttpRequest',
            //'enableCsrfValidation' => true,
            'class' => 'HttpRequest',
            'noCsrfValidationRoutes' => array(
                //'^users/GetList.*$'
                
                '^order/UploadDocuments.*$',
                '^inventory/UploadDocuments.*$',
                '^gmcupload/UploadDocuments.*$',
                '^gmcpriceupload/UploadDocuments.*$',
                '^gmcgoodsinupload/UploadDocuments.*$',
                '^initialbacklog/UploadDocuments.*$',
                 '^uploadsales/UploadDocuments.*$',
                 '^uploadbacklog/UploadDocuments.*$',
                 '^uploadunshipped/UploadDocuments.*$',
                 '^uploadstaticdata/UploadDocuments.*$',
                 '^hiddengmcuploads/UploadDocuments.*$',
                 '^credithold/UploadDocuments.*$',
                 '^inventoryreport/UploadDocuments.*$',
                 '^ordertakingreport/UploadDocuments.*$',
                 '^inventory/updateToYear.*$'
            ),
            'enableCsrfValidation' => true,
        ),
    ),
    // application-level parameters that can be accessed
    // using Yii::app()->params['paramName']
    'params' => array(
        // this is used in contact page
        'adminEmail' => 'admin@cumuluscrm.us',
        'defaultPageSize' => 5
    ),
    'behaviors' => array(
        'runEnd' => array(
            'class' => 'application.components.WebApplicationEndBehavior',
        ),
    ),
);