<?php
 class GmcpriceuploadController extends Controller {
    
    public function init() {
        parent::init();
        $this->initAjaxCsrfToken();
    }
 
    // this function will work to post csrf token.
    protected function initAjaxCsrfToken() {
 
       Yii::app()->clientScript->registerScript('AjaxCsrfToken', ' $.ajaxSetup({
                         data: {"YII_CSRF_TOKEN": "' . Yii::app()->request->csrfToken . '"},
                         cache:false
                    });', CClientScript::POS_HEAD);
    }

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index', 'UploadGMCPrice','UploadDocuments','DownloadpriceFormat','DownloadNewpriceFormat','SavePriceUpload','TestUpdatePrice',
                'SaveNewPriceUpload','SavePriceUploadTemp'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }
    public function actionUploadGMCPrice() {
        $_GET  = filter_input_array(INPUT_GET, FILTER_SANITIZE_SPECIAL_CHARS);
        if(count($_GET) > 0){
            $model = new GmcPriceUploads();
            Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.js' => false);
            $this->render('upload_form', array('model' => $model), false, false);
        }
        else{
              throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionDownloadpriceFormat(){
        $_GET  = filter_input_array(INPUT_GET, FILTER_SANITIZE_SPECIAL_CHARS);
        if(count($_GET) > 0){
            $id = Yii::app()->request->getParam('id');
            $product_category_id = Yii::app()->request->getParam('product_category_id');
            if((int)$product_category_id>0){
                
            }
            $sql_category = "SELECT C.id AS category_id,C.product_category,I.model_no,I.id,I.gmc_code
                        FROM {{inventory}} I
                        LEFT JOIN {{mas_product_category}} C ON C.id = I.product_category_id
                        ORDER by C.sort_order ASC
                        ";
            $model_inventory = Yii::app()->db->createCommand($sql_category)->queryAll();
            //$model_inventory = Inventory::model()->with('category_det')->findAll(array('order'=>'category_det.sort_order asc'));
            $file = fopen("upload/test.csv", "w");
            $j=0;
            $list[$j++] ='PRICE!';
            $firstrow ='GMC Code';
            $modMasRegion = MasRegion::model()->findAll(array('order'=>'id asc'));
            foreach($modMasRegion as $eachcat){
                $firstrow .='!'.$eachcat->region_name ;
            }
            $list[$j++] =$firstrow.'!'.'Model No'.'!'.'Category';
            foreach ($model_inventory as $i => $row) {
                $inv_row= $row['gmc_code'] ;
                foreach($modMasRegion as $eachreg){
                    $price = InventoryPrice::model()->find(array('condition' => 'product_id=' . (int) $row['id'].' AND region_id='.(int)$eachreg['id'],'order'=>'id DESC','limit'=>'1'))->price;
                    $inv_row .='!'.$price ;
                }
                $inv_row .='!'.$row['model_no'].'!'.$row['product_category'];
                $list[$j++] =$inv_row;
            }
            $j++;
            foreach ($list as $line) {
                fputcsv($file, explode('!', $line));
            }
            fclose($file);
            $filename = 'upload/test.csv';
            header("Content-Type: application/csv");
            header('Content-Disposition:attachment; filename="GMCPrice_downloadformat.csv"');
            readfile($filename);
            Yii::app()->end();
            return;
        }else{
            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionDownloadNewpriceFormat(){
        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_SPECIAL_CHARS);
        if (count($_GET) > 0) {
            $id = Yii::app()->request->getParam('id');
            
            // SQL to fetch all categories and inventory
            $sql_category = "SELECT C.id AS category_id, C.product_category, I.model_no, I.id, I.gmc_code,I.base_code,I.gmc_colour,I.base_category_name,
                            I.description,I.length,I.width,I.height,I.weight,I.barcode,I.origin,I.category_type_id,I.order_lot_to_ycj
                             FROM {{inventory}} I
                             LEFT JOIN {{mas_product_category}} C ON C.id = I.product_category_id
                             ORDER BY C.sort_order ASC";
            $model_inventory = Yii::app()->db->createCommand($sql_category)->queryAll();

            // Fetch all regions
            $modMasRegion = MasRegion::model()->findAll(array('order' => 'id ASC'));
            // Fetch all categry in a single query
            $modMasCategoryType = MasCategoryType::model()->findAll();
            $arr_categry = [];
            foreach ($modMasCategoryType as $d) {
                $arr_categry[$d->id] = $d->category_type_name;
            }
            //$region_ids = array_column($modMasRegion, 'id');

            // Prepare price lookup (batch query for all prices)
            //$product_ids = array_column($model_inventory, 'id');
            $sql_latest_price = "SELECT product_id, region_id, price,cost_price,cost_price_with_landing_cost,price_percentage
                             FROM {{inventory_price}} P
                             LEFT JOIN {{inventory}} I ON I.id = P.product_id
                             GROUP BY product_id,region_id
                             ORDER BY P.id DESC";// Ensures the latest price
            
            $prices = Yii::app()->db->createCommand($sql_latest_price)->queryAll();

            // Index prices for quick lookup
            $priceLookup = [];
            foreach ($prices as $p) {
                $priceLookup[$p['product_id']][$p['region_id']]['price'] = $p['price'];
                $priceLookup[$p['product_id']][$p['region_id']]['costprice'] = $p['cost_price'];
                $priceLookup[$p['product_id']][$p['region_id']]['landprice'] = $p['cost_price_with_landing_cost'];
                $priceLookup[$p['product_id']][$p['region_id']]['price_percentage'] = $p['price_percentage'];
            }
            //echo '<pre>';print_r($priceLookup);exit;
            /*// Helper function to populate a row with data
            function setData($worksheet, $rowNumber, $data) {
                $column = 'A';
                foreach ($data as $value) {
                    $worksheet->setCellValue("{$column}{$rowNumber}", $value);
                    $column++;
                }
            }
    
            // Helper function to set cell background color
            function setFillColor($worksheet, $range, $color) {
                $worksheet->getStyle($range)->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB($color);
            }
            
            $spreadsheet = new Spreadsheet();
            $activeWorksheet = $spreadsheet->getActiveSheet();
            
            // Set the title in merged cells
            $activeWorksheet->mergeCells('A1:I1');
            $activeWorksheet->setCellValue('A1', "YAMAHA MUSIC GULF FZE");
            $activeWorksheet->getStyle('A1:I1')->getFont()->setBold(true);
            $activeWorksheet->getStyle('A1')->getAlignment()->setVertical(\PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_CENTER);
            // Set font size to 16 for cell A1
            $activeWorksheet->getStyle('A1')->getFont()->setSize(16);
            $activeWorksheet->setCellValue('A2', "PIANO PRICE LIST");
            // Freeze the pane at cell C3
            $activeWorksheet->freezePane('C3');
            // Define and add column headers
            $columnHeaders = [
                'REGION', 'CATEGORY', '0','1','2','3','4','4+','Grand Total'
            ];
            */
            
            
            
            // Prepare CSV data
            $file = fopen("upload/test.csv", "w");
            $list = [];
            $list[] = [];
            $list[] = [];
            $list[] = [];
            $list[] = [];
            $list[] = [];
            $list[] = [];
            $firstRow[] = 'Category';
            $firstRow[] = 'GMC Code';
            $firstRow[] = 'Base Code';
            $firstRow[] = 'Model No';
            $firstRow[] = 'Color';
            $firstRow[] = 'Base Category';
            $firstRow[] = 'YCJ FCA';
            $firstRow[] = 'YMGF L.I.C.';
            foreach ($modMasRegion as $region) {
                $firstRow[] = $region->region_name;
                //$firstRow[] = $region->region_name.' Margin On Old LIC';
                $firstRow[] = 'YMGF MRG';
            }
            $firstRow[] = 'Description';
            $firstRow[] = 'Origin';
            /*$firstRow[] = 'Length';
            $firstRow[] = 'Width';
            $firstRow[] = 'Height';
            $firstRow[] = 'Kg';
            $firstRow[] = 'Barcode';
            $firstRow[] = 'Origin';*/
            $firstRow[] = 'Category';
            //$firstRow[] = 'Order Lot to YCJ';
            $list[] = $firstRow;

            // Populate data
            foreach ($model_inventory as $row) {
                $inv_row = [$row['product_category']];
                $inv_row[] = $row['gmc_code'];
                $inv_row[] = $row['base_code'];
                $inv_row[] = $row['model_no'];
                $inv_row[] = $row['gmc_colour'];
                $inv_row[] = $row['base_category_name'];
                
                $i=0;
                foreach ($modMasRegion as $i=>$region) {
                    $price = isset($priceLookup[$row['id']][$region->id]['price']) ? $priceLookup[$row['id']][$region->id]['price'] : '';
                    $cprice= isset($priceLookup[$row['id']][$region->id]['costprice']) ? $priceLookup[$row['id']][$region->id]['costprice'] : '';
                    $lprice= isset($priceLookup[$row['id']][$region->id]['landprice']) ? $priceLookup[$row['id']][$region->id]['landprice'] : '';
                    $price_percentage=isset($priceLookup[$row['id']][$region->id]['price_percentage']) ? $priceLookup[$row['id']][$region->id]['price_percentage'] : '';
                    if($i==0){
                        $inv_row[] = $cprice;
                        $inv_row[] = $lprice;
                    }
                    $inv_row[] = $price;
                    $inv_row[] = $price_percentage;
                }
                $inv_row[] = $row['description'];
               /* $inv_row[] = $row['gmc_colour'];
                $inv_row[] = $row['length'];
                $inv_row[] = $row['width'];
                $inv_row[] = $row['height'];
                $inv_row[] = $row['weight'];
                $inv_row[] = $row['barcode'];*/
                $inv_row[] = $row['origin'];
                $inv_row[] = $arr_categry[$row['category_type_id']];
                //$inv_row[] = $row['order_lot_to_ycj'];
                $list[] = $inv_row;
            }

            // Write all rows to CSV at once
            foreach ($list as $line) {
                fputcsv($file, $line);
            }
            fclose($file);

            // Send the file to download
            $filename = 'upload/test.csv';
            header("Content-Type: application/csv");
            header('Content-Disposition: attachment; filename="GMCPrice_downloadformat.csv"');
            readfile($filename);
            Yii::app()->end();
            return;
        } else {
            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionSavePriceUpload() {
        
        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if (count($_POST) > 0) {
            $model = new GmcPriceUploads();
            $other = array();
            if (isset($_POST['GmcPriceUploads'])) {
                if ((int) @$_POST['GmcPriceUploads']['id'] > 0) {
                    $id = (int) @$_POST['GmcPriceUploads']['id'];
                    $model = $model->findByPk($id);
                } else {
                    $model->created_by = Yii::app()->user->id;
                    $model->created_date_time = date('Y-m-d H:i:s');
                }
                $model->updated_by = Yii::app()->user->id;
                $model->updated_date_time = date('Y-m-d H:i:s');
                $model->attributes = $_POST['GmcPriceUploads'];
                $model->upload_date = date('Y-m-d');
                if($_POST['GmcPriceUploads']['from_date']!='01/01/1970' && $_POST['GmcPriceUploads']['from_date'] != '')
                {
                    $model->from_date = str_replace('/', '-', $_POST['GmcPriceUploads']['from_date']);
                    $model->from_date= date("Y-m-d", strtotime($model->from_date));
                }
                $file = $_POST['GmcPriceUploads']['file_name'];
                $model->file_name = $file;
                $valid = $model->validate();
                $i = 0;$j=0;
                $arr_products = [];
                $n = 1;$arr_regions=[];$arr_region_ids=[];$j=0;
                if ($file != '') {
                    if (($handle = fopen("upload/price/" . $file, "r")) !== FALSE) {
                        
                        while (($row = fgetcsv($handle)) !== FALSE) {
                            if ($n == 2) {
                                $row_count = count($row)-2;
                                for ($k = 1; $k < $row_count; $k++) {
                                    $region_name = trim($row[$k], '\'"'); //region_name
                                    $arr_regions[$k] = $region_name;
                                    if ($row[$k] == '') {
                                        $other[] = 'Heading Region Missing';
                                        $valid = false;
                                    }else{
                                        $modMasRegion  = MasRegion::model()->find(array('condition' => 'region_name="' . $region_name . '"'));
                                        if(!empty($modMasRegion)){
                                            $region_id = $modMasRegion->id;
                                            $arr_region_ids[$k] = $region_id;
                                        }else{
                                            $other[] = 'Region '.$region_name.' Not Exists';
                                            $valid = false;
                                        }
                                    }
                                }
                            
                            }
                            if ($n > 2) {
                                $gmc_code = trim($row[0]); //gmc
                                $mod_inv = Inventory::model()->find(array('condition' => 'gmc_code="'.$gmc_code.'"'));//AND is_active="Y"
                                if (!empty($mod_inv)) {
                                    for ($i = 1; $i < $row_count; $i++) {
                                        $model_history = InventoryPrice::model()->find(array('condition'=>'region_id ='.(int)$arr_region_ids[$i].' AND product_id ='.(int)$mod_inv['id'],'order'=>'id DESC'));
                                        $new_from_date=$model->from_date;
                                        $modelItems[$j] = new InventoryPrice;
                                        $modelItems[$j]->created_by = Yii::app()->user->id;
                                        $modelItems[$j]->created_date_time = date("Y-m-d H:i:s");
                                        $modelItems[$j]->region_id = $arr_region_ids[$i];
                                        $modelItems[$j]->price = (float)$row[$i];
                                        $modelItems[$j]->product_id = $mod_inv['id'];
                                        $modelItems[$j]->from_date = $new_from_date;
                                        $modelItems[$j]->to_date = "2099-12-31";
                                        $valid = $modelItems[$j]->validate() && $valid;
                                        $j++;
                                        if(!empty($model_history)){
                                            $modelItems[$j] =  InventoryPrice::model()->findByPK((int)$model_history->id);
                                            $modelItems[$j]->updated_by = Yii::app()->user->id;
                                            $modelItems[$j]->updated_date_time = date("Y-m-d H:i:s");
                                            $modelItems[$j]->to_date = $new_from_date;
                                            $valid = $modelItems[$j]->validate() && $valid;
                                            $j++;
                                        }
                                    }
                                   
                                } else {
                                    $other[] = 'GMC with code '.$gmc_code.' not exits';
                                    $valid = false;
                                    /*$cnd = 'gmc_code="'.$gmc_code.'" AND is_active="D" '; //
                                    $mod_inv = Inventory::model()->find(array('condition'=>$cnd));
                                    if(!empty($mod_inv)){
                                        $other[] = 'GMC with code '.$gmc_code.' Discontinued';
                                    }else{
                                        
                                    }*/
                                    
                                }
                            }
                            $n++;
                        }
                        fclose($handle);
                    }
                } else {
                    $other[] = 'File Not Uploaded';
                    $valid = false;
                }
                /*echo '<pre>';
                print_r($modelItems);
                exit;*/
                if ($valid) {

                    $model->save();
                    if (!empty($modelItems)) {
                        foreach ($modelItems as $each) {
                            $each->save(false);
                            OrderDetails::model()->updateAll(array('price' => (float)$each['price']),'product_id='.(int)$each['product_id'].' AND region_id='.(int)$each['region_id'].' AND order_date>="'.$each['from_date'].'" AND order_date<"'.$each['to_date'] .'" '  );
                        }
                    }
                    $jsonData['status'] = 'success';
                    $jsonData['frm'] = $_POST['GmcPriceUploads'];
                    $jsonData['id'] = $model->id;
                    echo CJSON::encode($jsonData);
                } else {
                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    if (!empty($modelItems)) {
                        $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                    } else {
                        $error2[] = "Please add atleast one line item";
                    }
                    $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                    if ($error != '[]')
                        echo $error;
                }
            }
        }
        else {
            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionSaveNewPriceUpload() {

        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if (count($_POST) > 0) {
            $model = new GmcPriceUploads();
            $other = array();
            if (isset($_POST['GmcPriceUploads'])) {
                if ((int) @$_POST['GmcPriceUploads']['id'] > 0) {
                    $id = (int) @$_POST['GmcPriceUploads']['id'];
                    $model = $model->findByPk($id);
                } else {
                    $model->created_by = Yii::app()->user->id;
                    $model->created_date_time = date('Y-m-d H:i:s');
                }
                $model->updated_by = Yii::app()->user->id;
                $model->updated_date_time = date('Y-m-d H:i:s');
                $model->attributes = $_POST['GmcPriceUploads'];
                $model->upload_date = date('Y-m-d');
                $model->lic_percent = $_POST['GmcPriceUploads']['lic_percent'];// added by lidiya
                if($_POST['GmcPriceUploads']['from_date']!='01/01/1970' && $_POST['GmcPriceUploads']['from_date'] != '')
                {
                    $model->from_date = str_replace('/', '-', $_POST['GmcPriceUploads']['from_date']);
                    $model->from_date= date("Y-m-d", strtotime($model->from_date));
                }
                $file = $_POST['GmcPriceUploads']['file_name'];
                $model->file_name = $file;
                $valid = $model->validate();
                $i = 0;$j=0;$r=0;
                $arr_products = [];
                $n = 1;$arr_regions=[];$arr_region_ids=[];$arr_region_currency=[];$j=0;
                $modCattype= new MasCategoryType();
                if ($file != '') {
                    if (($handle = fopen("upload/price/" . $file, "r")) !== FALSE) {
                        while (($row = fgetcsv($handle)) !== FALSE) {
                            // If an empty row is found, break the loop.
                            if ($n > 7 && empty(array_filter($row))) {
                                break;  // Stop reading further rows once you find an empty row
                            }
                            else if ($n == 7) {
                                $row_count = count($row)-3;
                                for ($k = 8; $k < $row_count;  $k += 2) {
                                    $region_name = trim($row[$k], '\'"'); //region_name
                                    $region_name = preg_replace("/\s*\(.*?\)/", "", $region_name); // Remove everything inside ()
                                    $arr_regions[$k] = $region_name;
                                    if ($row[$k] == '') {
                                        $other[] = 'Heading Region Missing';
                                        $valid = false;
                                    }else{
                                        $modMasRegion  = MasRegion::model()->find(array('condition' => 'region_name="' . $region_name . '"'));
                                        if(!empty($modMasRegion)){
                                            $region_id = $modMasRegion->id;
                                            $arr_region_ids[$k] = $region_id;
                                            $arr_region_currency[$k]=$modMasRegion->currency_type;
                                        }else{
                                            $other[] = 'Region '.$region_name.' Not Exists'.$k.' '.$n;
                                            $valid = false;
                                        }
                                    }
                                }
                            
                            }
                            else if ($n > 7) {
                                $gmc_code = trim($row[1]); //gmc
                                $model_name = trim($row[2]); //model_name
                                $base_code = trim($row[3]); //base_code
                                $base_category_code = trim($row[4]); //base_category_code
                                $base_category_name = trim($row[5]);
                                $purchase_cost = (float)str_replace(['$', ','], '', $row[6]);
                                $purchase_cost_with_landing = (float)str_replace(['$', ','], '', $row[7]);
                                // ,base_category_code,base_category_name,description,origin,category_type_id
                           
                                $mod_inv[$r] = Inventory::model()->find(array('condition' => 'gmc_code="'.$gmc_code.'"'));//AND is_active="Y"
                                if (empty($mod_inv[$r])) {
                                    $mod_inv[$r] = new Inventory();
                                    $mod_inv[$r]->product_category_id = (int) $category_id;
                                    $mod_inv[$r]->gmc_sort_order = 5000;
                                    $mod_inv[$r]->gmc_code = $gmc_code;
                                    $mod_inv[$r]->model_no = $model_name;
                                    $mod_inv[$r]->cbm = 0;
                                    $mod_inv[$r]->base_code = $base_code;
                                    $mod_inv[$r]->new_till_year = '0000';
                                    $mod_inv[$r]->new_till_month =0;
                                    $mod_inv[$r]->gmc_colour ='';
                                    $mod_inv[$r]->base_category_code =$base_category_code;
                                    $mod_inv[$r]->base_category_name =$base_category_name;
                                    $mod_inv[$r]->cable_modeification ='';
                                    $mod_inv[$r]->goods_in_month = 0;
                                    $mod_inv[$r]->goods_in_year = '0000';
                                    $mod_inv[$r]->goods_in_end_month = 0;
                                    $mod_inv[$r]->goods_in_end_year = '0000';
                                    $mod_inv[$r]->backlog_month = 0;
                                    $mod_inv[$r]->backlog_year = '0000';
                                    $mod_inv[$r]->backlog_end_month = 0;
                                    $mod_inv[$r]->backlog_end_year = '0000';
                                    $mod_inv[$r]->is_active = 'Y';
                                    $mod_inv[$r]->created_by = Yii::app()->user->id;
                                    $mod_inv[$r]->created_date_time = date('Y-m-d H:i:s');
                                    $mod_inv[$r]->updated_by = Yii::app()->user->id;
                                    $mod_inv[$r]->updated_date_time = date('Y-m-d H:i:s');
                                    $mod_inv[$r]->save(false);
                                    $mod_inv[$r]->refresh();
                                }else{
                                    if(!empty($base_category_code))
                                    $mod_inv[$r]->base_category_code=$base_category_code;
                                    if(!empty($base_category_name))
                                    $mod_inv[$r]->base_category_name=$base_category_name;
                                    if(!empty($model_name))
                                    $mod_inv[$r]->model_no=$model_name;
                                    if(!empty($base_code))
                                    $mod_inv[$r]->base_code=$base_code;
                                }
                                for ($i = 8; $i < $row_count; $i += 2) {
                                    $model_history = InventoryPrice::model()->find(array('condition'=>'region_id ='.(int)$arr_region_ids[$i].' AND product_id ='.(int)$mod_inv[$r]['id'],'order'=>'id DESC'));
                                    $new_from_date=$model->from_date;
                                    $price = (float)str_replace(['$', ','], '',$row[$i]);
                                    $price_percentage=(((float)$price)!=0)?((float)$price-(float)$purchase_cost_with_landing)/((float)$price):0;
                                    $modelItems[$j] = new InventoryPrice;
                                    $modelItems[$j]->created_by = Yii::app()->user->id;
                                    $modelItems[$j]->created_date_time = date("Y-m-d H:i:s");
                                    $modelItems[$j]->region_id = $arr_region_ids[$i];
                                    $modelItems[$j]->cost_price = (float)$purchase_cost;
                                    $modelItems[$j]->cost_price_with_landing_cost = (float)$purchase_cost_with_landing;
                                    $modelItems[$j]->price_percentage = (float)$price_percentage;
                                    $modelItems[$j]->price = (float)str_replace(['$', ','], '',$row[$i]);
                                    $modelItems[$j]->product_id = $mod_inv[$r]['id'];
                                    $modelItems[$j]->from_date = $new_from_date;
                                    $modelItems[$j]->to_date = "2999-12-31";
                                    $valid = $modelItems[$j]->validate() && $valid;
                                    $j++;
                                    if(!empty($model_history)){
                                        $modelItems[$j] =  InventoryPrice::model()->findByPK((int)$model_history->id);
                                        $modelItems[$j]->updated_by = Yii::app()->user->id;
                                        $modelItems[$j]->updated_date_time = date("Y-m-d H:i:s");
                                        $modelItems[$j]->to_date = $new_from_date;
                                        $valid = $modelItems[$j]->validate() && $valid;
                                        $j++;
                                    }
                                    
                                }
                                if(trim($row[$i])!='')
                                $mod_inv[$r]->description=trim($row[$i]);
                                if(trim($row[$i+1])!='')
                                $mod_inv[$r]->origin=trim($row[$i+1]);
                                $category_type =trim($row[$i+2]);
                                $category_type_id= $modCattype->find(['condition'=>'category_type_name="'.$category_type.'"'])->id;
                                if((int)$category_type_id>0){
                                    $mod_inv[$r]->category_type_id=$category_type_id;
                                }else{
                                    $modMasCattype= new MasCategoryType();
                                    $modMasCattype->category_type_name =$category_type;
                                    $modMasCattype->save(false);
                                    $category_type_id= $modMasCattype->id;
                                }
                                $r++;
                                if(empty($gmc_code))
                                break;
                            }
                            $n++;
                            
                        }
                        fclose($handle);
                    }
                } else {
                    $other[] = 'File Not Uploaded';
                    $valid = false;
                }
                /*echo '<pre>';
                echo 'inv';print_r($mod_inv);
                echo 'reg';print_r($arr_regions);
                echo 'it';print_r($modelItems);
                exit;*/
                if ($valid) {

                    $model->save();
                    if (!empty($mod_inv)) {
                        foreach ($mod_inv as $eachi) {
                            $eachi->save(false);
                        }
                    }
                    if (!empty($modelItems)) {
                        foreach ($modelItems as $each) {
                            $each->save(false);
                            OrderDetails::model()->updateAll(array('price' => (float)$each['price']),'product_id='.(int)$each['product_id'].' AND region_id='.(int)$each['region_id'].' AND order_date>="'.$each['from_date'].'" AND order_date<"'.$each['to_date'] .'" '  );
                        }
                    }
                    $jsonData['status'] = 'success';
                    $jsonData['frm'] = $_POST['GmcPriceUploads'];
                    $jsonData['id'] = $model->id;
                    echo CJSON::encode($jsonData);
                } else {
                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    if (!empty($modelItems)) {
                        $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                    } else {
                        $error2[] = "Please add atleast one line item";
                    }
                    $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                    if ($error != '[]')
                        echo $error;
                }
            }
        }
        else {
            throw new CHttpException(404, 'Page not found.');
        }
    }
    
    public function actionTestUpdatePrice(){
        $modelItems= InventoryPrice::model()->findALL();
        if (!empty($modelItems)) {
            foreach ($modelItems as $each) {
                OrderDetails::model()->updateAll(array('price' => (float)$each['price']),'product_id='.(int)$each['product_id'].' AND region_id='.(int)$each['region_id'].' AND order_date>="'.$each['from_date'].'" AND order_date<"'.$each['to_date'] .'" '  );
            }
        }
        echo 'success';
    }




    public function actionSavePriceUploadTemp() {

        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if (count($_POST) > 0) {
            $model = new GmcPriceUploads();
            $other = array();
            if (isset($_POST['GmcPriceUploads'])) {
                if ((int) @$_POST['GmcPriceUploads']['id'] > 0) {
                    $id = (int) @$_POST['GmcPriceUploads']['id'];
                    $model = $model->findByPk($id);
                } else {
                    $model->created_by = Yii::app()->user->id;
                    $model->created_date_time = date('Y-m-d H:i:s');
                }
                $model->updated_by = Yii::app()->user->id;
                $model->updated_date_time = date('Y-m-d H:i:s');
                $model->attributes = $_POST['GmcPriceUploads'];
                $model->upload_date = date('Y-m-d');
                $model->lic_percent = $_POST['GmcPriceUploads']['lic_percent']; 
                $lic_percent = $_POST['GmcPriceUploads']['lic_percent'];
                if($_POST['GmcPriceUploads']['from_date']!='01/01/1970' && $_POST['GmcPriceUploads']['from_date'] != '')
                {
                    $model->from_date = str_replace('/', '-', $_POST['GmcPriceUploads']['from_date']);
                    $model->from_date= date("Y-m-d", strtotime($model->from_date));
                }
                $file = $_POST['GmcPriceUploads']['file_name'];
                $model->file_name = $file;
                $valid = $model->validate();
                $i = 0;$j=0;$r=0;
                $arr_products = [];
                $n = 1;$arr_regions=[];$arr_region_ids=[];$arr_region_currency=[];$j=0;
                $modCattype= new MasCategoryType();
                if ($file != '') {
                    if (($handle = fopen("upload/price/" . $file, "r")) !== FALSE) {
                        while (($row = fgetcsv($handle)) !== FALSE) {
                            // If an empty row is found, break the loop.
                            if ($n > 7 && empty(array_filter($row))) {
                                break;  // Stop reading further rows once you find an empty row
                            }
                            else if ($n == 7) {
                                $row_count = count($row)-3;
                                for ($k = 8; $k < $row_count;  $k += 2) {
                                    $region_name = trim($row[$k], '\'"'); //region_name
                                    $region_name = preg_replace("/\s*\(.*?\)/", "", $region_name); // Remove everything inside ()
                                    $arr_regions[$k] = $region_name;
                                    if ($row[$k] == '') {
                                        $other[] = 'Heading Region Missing';
                                        $valid = false;
                                    }else{
                                        $modMasRegion  = MasRegion::model()->find(array('condition' => 'region_name="' . $region_name . '"'));
                                        if(!empty($modMasRegion)){
                                            $region_id = $modMasRegion->id;
                                            $arr_region_ids[$k] = $region_id;
                                            $arr_region_currency[$k]=$modMasRegion->currency_type;
                                        }else{
                                            $other[] = 'Region '.$region_name.' Not Exists'.$k.' '.$n;
                                            $valid = false;
                                        }
                                    }
                                }
                            
                            }
                            else if ($n > 7) {
                                $gmc_code = trim($row[1]); //gmc
                                $model_name = trim($row[2]); //model_name
                                $base_code = trim($row[3]); //base_code
                                $base_category_code = trim($row[4]); //base_category_code
                                $base_category_name = trim($row[5]);
                                $purchase_cost = (float)str_replace(['$', ','], '', $row[6]);
                                $purchase_cost_with_landing = (float)str_replace(['$', ','], '', $row[7]);
                                // ,base_category_code,base_category_name,description,origin,category_type_id
                           
                                $mod_inv[$r] = Inventory::model()->find(array('condition' => 'gmc_code="'.$gmc_code.'"'));//AND is_active="Y"
                                if (empty($mod_inv[$r])) {
                                    $mod_inv[$r] = new Inventory();
                                    $mod_inv[$r]->product_category_id = (int) $category_id;
                                    $mod_inv[$r]->gmc_sort_order = 5000;
                                    $mod_inv[$r]->gmc_code = $gmc_code;
                                    $mod_inv[$r]->model_no = $model_name;
                                    $mod_inv[$r]->cbm = 0;
                                    $mod_inv[$r]->base_code = $base_code;
                                    $mod_inv[$r]->new_till_year = '0000';
                                    $mod_inv[$r]->new_till_month =0;
                                    $mod_inv[$r]->gmc_colour ='';
                                    $mod_inv[$r]->base_category_code =$base_category_code;
                                    $mod_inv[$r]->base_category_name =$base_category_name;
                                    $mod_inv[$r]->cable_modeification ='';
                                    $mod_inv[$r]->goods_in_month = 0;
                                    $mod_inv[$r]->goods_in_year = '0000';
                                    $mod_inv[$r]->goods_in_end_month = 0;
                                    $mod_inv[$r]->goods_in_end_year = '0000';
                                    $mod_inv[$r]->backlog_month = 0;
                                    $mod_inv[$r]->backlog_year = '0000';
                                    $mod_inv[$r]->backlog_end_month = 0;
                                    $mod_inv[$r]->backlog_end_year = '0000';
                                    $mod_inv[$r]->is_active = 'Y';
                                    $mod_inv[$r]->created_by = Yii::app()->user->id;
                                    $mod_inv[$r]->created_date_time = date('Y-m-d H:i:s');
                                    $mod_inv[$r]->updated_by = Yii::app()->user->id;
                                    $mod_inv[$r]->updated_date_time = date('Y-m-d H:i:s');
                                    $mod_inv[$r]->save(false);
                                    $mod_inv[$r]->refresh();
                                }else{
                                    if(!empty($base_category_code))
                                    $mod_inv[$r]->base_category_code=$base_category_code;
                                    if(!empty($base_category_name))
                                    $mod_inv[$r]->base_category_name=$base_category_name;
                                    if(!empty($model_name))
                                    $mod_inv[$r]->model_no=$model_name;
                                    if(!empty($base_code))
                                    $mod_inv[$r]->base_code=$base_code;
                                }
                                for ($i = 8; $i < $row_count; $i += 2) {
                                     $new_from_date=$model->from_date;
                                    $price = (float)str_replace(['$', ','], '',$row[$i]);
                                    $cost_with_lic = (float)$purchase_cost * (float)$lic_percent;
                                    $price_percentage=(((float)$price)!=0)?((float)$price-(float)$cost_with_lic)/((float)$price):0;
                                    // $price_percentage = 0;
                                    // if($price>0)
                                    // {
                                    // $price_percentage = ((float)$price-(float)$cost_with_lic)/(float)$price;
                                    // }
                                   // $price_percentage=(((float)$price)!=0)?((float)$price-(float)$purchase_cost_with_landing)/((float)$price):0;
                                    $modelItems[$j] = new TempInventoryPrice;
                                    $modelItems[$j]->created_by = Yii::app()->user->id;
                                    $modelItems[$j]->created_date_time = date("Y-m-d H:i:s");
                                    $modelItems[$j]->region_id = $arr_region_ids[$i];
                                    $modelItems[$j]->cost_price = (float)$purchase_cost;
                                    //$modelItems[$j]->cost_price_with_landing_cost = (float)$purchase_cost_with_landing;
                                    $modelItems[$j]->price_percentage = (float)round($price_percentage,2);
                                    $modelItems[$j]->price = (float)str_replace(['$', ','], '',$row[$i]);
                                    $modelItems[$j]->product_id = $mod_inv[$r]['id'];
                                    $modelItems[$j]->from_date = $new_from_date;
                                    $modelItems[$j]->to_date = "2999-12-31";
                                    $modelItems[$j]->upload_id = 0;
                                    $modelItems[$j]->lic_percentage = 0;
                                    $valid = $modelItems[$j]->validate() && $valid;
                                    $j++;
                                    
                                    
                                }
                                if(trim($row[$i])!='')
                                $mod_inv[$r]->description=trim($row[$i]);
                                if(trim($row[$i+1])!='')
                                $mod_inv[$r]->origin=trim($row[$i+1]);
                                $category_type =trim($row[$i+2]);
                                $category_type_id= $modCattype->find(['condition'=>'category_type_name="'.$category_type.'"'])->id;
                                if((int)$category_type_id>0){
                                    $mod_inv[$r]->category_type_id=$category_type_id;
                                }else{
                                    $modMasCattype= new MasCategoryType();
                                    $modMasCattype->category_type_name =$category_type;
                                    $modMasCattype->save(false);
                                    $category_type_id= $modMasCattype->id;
                                }
                                $r++;
                                if(empty($gmc_code))
                                break;
                            }
                            $n++;
                            
                        }
                        fclose($handle);
                    }
                } else {
                    $other[] = 'File Not Uploaded';
                    $valid = false;
                }
                /*echo '<pre>';
                echo 'inv';print_r($mod_inv);
                echo 'reg';print_r($arr_regions);
                echo 'it';print_r($modelItems);
                exit;*/
                if ($valid) {

                    $model->save();
                    if (!empty($mod_inv)) {
                        foreach ($mod_inv as $eachi) {
                            $eachi->save(false);
                        }
                    }
                    if (!empty($modelItems)) {
                        foreach ($modelItems as $each) {
                            $each->upload_id = $model->id;
                            $each->lic_percentage = $model->lic_percent;
                            $each->save(false);
                            OrderDetails::model()->updateAll(array('price' => (float)$each['price']),'product_id='.(int)$each['product_id'].' AND region_id='.(int)$each['region_id'].' AND order_date>="'.$each['from_date'].'" AND order_date<"'.$each['to_date'] .'" '  );
                        }
                    }
                    $jsonData['status'] = 'success';
                    $jsonData['frm'] = $_POST['GmcPriceUploads'];
                    $jsonData['id'] = $model->id;
                    echo CJSON::encode($jsonData);
                } else {
                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    if (!empty($modelItems)) {
                        $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                    } else {
                        $error2[] = "Please add atleast one line item";
                    }
                    $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                    if ($error != '[]')
                        echo $error;
                }
            }
        }
        else {
            throw new CHttpException(404, 'Page not found.');
        }
    }
 }