<?php

class HiddengmcuploadsController extends Controller {

    public function init() {
        parent::init();
        $this->initAjaxCsrfToken();
    }

    // this function will work to post csrf token.
    protected function initAjaxCsrfToken() {

        Yii::app()->clientScript->registerScript('AjaxCsrfToken', ' $.ajaxSetup({
                         data: {"YII_CSRF_TOKEN": "' . Yii::app()->request->csrfToken . '"},
                         cache:false
                    });', CClientScript::POS_HEAD);
    }

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index', 'DownloadFormat', 'UploadGMC', 'SaveGMCUpload', 'UploadDocuments', 'DownloadGmcFormat','DeleteRow'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionUploadGMC() {
        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
        if (count($_GET) > 0) {
            $header_id = (int) Yii::app()->request->getParam('id');
            $model = new HiddenGmcUploads();

            Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.js' => false);
            $this->render('upload_form', array('model' => $model,'header_id'=>$header_id), false, false);
        } else {
            throw new CHttpException(404, 'Page not found.');
        }
    }

    public function actionDownloadGmcFormat() {
        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
        if (count($_GET) > 0) {
            $file = fopen("upload/test.csv", "w");
            $j = 0;
            $list[$j++] = 'GMC!Model';
            $model_HiddenDistributerGmcs = HiddenDistributerGmcs::model()->with('gmc_det','gmc_det.category_det')->findAll(array('condition' => 'distributer_type_id="'.$_GET['header_id'].'"'));
            foreach ($model_HiddenDistributerGmcs as $row) {
                $list[$j++] =  $row['gmc_det']['gmc_code'].'!'.$row['gmc_det']['model_no'] ;
            }
            $j++;
            foreach ($list as $line) {
                fputcsv($file, explode('!', $line));
            }
            fclose($file);
            $filename = 'upload/test.csv';
            header("Content-Type: application/csv");
            header('Content-Disposition:attachment; filename="Hidden_GMC_downloadformat.csv"');
            readfile($filename);
            Yii::app()->end();
            return;
        } else {
            throw new CHttpException(404, 'Page not found.');
        }
    }

    public function actionSaveGMCUpload() {

        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if (count($_POST) > 0) {
            $model = new HiddenGmcUploads();
            $other = array();
            if (isset($_POST['HiddenGmcUploads'])) {
                if ((int) @$_POST['HiddenGmcUploads']['id'] > 0) {
                    $id = (int) @$_POST['HiddenGmcUploads']['id'];
                    $model = $model->findByPk($id);
                } else {
                    $model->created_by = Yii::app()->user->id;
                    $model->created_date_time = date('Y-m-d H:i:s');
                }
                $model->updated_by = Yii::app()->user->id;
                $model->updated_date_time = date('Y-m-d H:i:s');
                $model->attributes = $_POST['HiddenGmcUploads'];
                $model->upload_date = date('Y-m-d');
                $model->distributer_type_id= $_POST['HiddenGmcUploads']['distributer_type_id'];
                $file = $_POST['HiddenGmcUploads']['file_name'];

               
                $model->file_name = $file;
                $valid = $model->validate();
                $modHiddenDistributerGmcs = new HiddenDistributerGmcs();
                $i = 0;
                $arr_products = [];
                $n = 1;
                if ($file != '' && $file !== 'undefined') {
                    if (($handle = fopen("upload/hiddengmc/" . $file, "r")) !== FALSE) {

                        while (($row = fgetcsv($handle)) !== FALSE) {

                            if ($n > 1) {
                                $pdt_cat = trim($row[1], '\'"'); //productcategory
                                $gmc_code = trim($row[0], '\'"'); //gmccode
                                /*$category_id = (int) MasProductCategory::model()->find(array('condition' => 'product_category="' . $product_category . '"'))->id;
                                if ($category_id == 0) {
                                    $other[] = ' Category ' . $product_category . ' not added';
                                    $valid = false;
                                }*/
                                $mod_inv = Inventory::model()->find(array('condition' => 'gmc_code="' . $gmc_code . '"'));
                                
                                if (!empty($mod_inv)) {
                                    if (in_array($gmc_code, $arr_products)) {
                                        $other[] = $gmc_code . ' GMC Repeated ';
                                        $valid = false;
                                    } else {
                                        $arr_products[] = $gmc_code;
                                    }
                                    $modelItems[$i] = $modHiddenDistributerGmcs->find(['condition'=>'product_id='.(int) $mod_inv->id]);
                                    if(empty($modelItems[$i])){
                                        $modelItems[$i] = new HiddenDistributerGmcs();
                                        $modelItems[$i]->distributer_type_id=$model->distributer_type_id;
                                        $modelItems[$i]->product_id = $mod_inv->id;
                                        $i++;
                                    }
                                } else {
                                    $other[] = $gmc_code . ' GMC Not Exists ';
                                    $valid = false;
                                }
                            }
                            $n++;
                        }
                        fclose($handle);
                    }
                } else {
                    $other[] = 'File Not Uploaded';
                    $valid = false;
                }
                /*echo '<pre>';
                print_r($modelItems);
                exit;*/
                if ($valid) {

                    $model->save();
                    if (!empty($modelItems)) {
                        foreach ($modelItems as $each) {
                            $each->save(false);
                        }
                    }
                    $jsonData['status'] = 'success';
                    $jsonData['frm'] = $_POST['HiddenGmcUploads'];
                    $jsonData['id'] = $model->id;
                    echo CJSON::encode($jsonData);
                } else {
                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    if (!empty($modelItems)) {
                        $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                    } else {
                        $error2[] = "Please add atleast one line item";
                    }
                    $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                    if ($error != '[]')
                        echo $error;
                }
            }
        }
        else {
            throw new CHttpException(404, 'Page not found.');
        }
    }


    public function actionUploadDocuments($folder = null,$filename=null) {

    	Yii::import("ext.EAjaxUpload.qqFileUploader");

    	$field_id = "";

    	if(isset($_GET['field_id']))

    	{

    		$field_id = Yii::app()->request->getParam('field_id');

    	}
        if(empty($filename)){
            $filename='Documents_'.date('YmdHis');
        }
        /*echo $field_id.'<br>';   
        echo $folder;*/


    	$folder = Yii::getPathOfAlias('webroot') . '/' . $folder . '/';

        

        

    	// make the directory to store the pic:

    	if (!is_dir($folder)) {

    		mkdir($folder, 0777, TRUE);

    	}

    	$allowedExtensions = array("jpg", "jpeg", "gif","png","csv","pdf","xls","xlsx"); //array("jpg","jpeg","gif","exe","mov" and etc...

    	$sizeLimit = 8 * 1024 * 1024; // maximum file size in bytes

    	$uploader = new qqFileUploader($allowedExtensions, $sizeLimit);

    	$result = $uploader->handleUpload($folder,FALSE,$filename);

    	$result['fileType'] = pathinfo($folder . $result['filename'], PATHINFO_EXTENSION);

    	$result['field_id'] = $field_id;

    	$return = htmlspecialchars(json_encode($result), ENT_NOQUOTES);
    	echo $return; // it's array

    }
    public function actionDeleteRow() {

        $id = $_POST['id'];
        
        //$model_history = Company::model()->findAll(array('condition' => 'shipping_country = ' . $id . ' '));
        $jsonData=array();
        if ($id > 0) {
            $model = new HiddenDistributerGmcs();
            $model->deleteByPk($id);
             $jsonData['status'] = 'success';
        } else {
            $jsonData['status'] = 'error';
        }
        echo CJSON::encode($jsonData);
    }

}
