<?php
 class InitialbacklogController extends Controller {
    
    public function init() {
        parent::init();
        $this->initAjaxCsrfToken();
    }
 
    // this function will work to post csrf token.
    protected function initAjaxCsrfToken() {
 
       Yii::app()->clientScript->registerScript('AjaxCsrfToken', ' $.ajaxSetup({
                         data: {"YII_CSRF_TOKEN": "' . Yii::app()->request->csrfToken . '"},
                         cache:false
                    });', CClientScript::POS_HEAD);
    }

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index', 'uploadbacklog','GetList', 'DownloadbacklogFormat','UploadDocuments','SavebacklogUpload','DeleteBackLog','DownloadUploaded'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }
    public function actionIndex() {
       // if (isset(Yii::app()->user->havePermissionOn['card']) || Yii::app()->user->authorised_user == 1) {
            $this->render('index');
      //  } else {
         //   throw new CHttpException(403, 'access denied.');
       // }
    }
    public function actionGetList() {
        $_POST  = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if(count($_POST) > 0){
            $model = new UploadInitialBacklogShipment();
            $draw = $_POST['draw'];
            $offset = $_POST['start'];
            $limit = $_POST['length'];
            $year = $_POST['year'];
            $month = $_POST['month'];
            $columns = array(
                // datatable column index  => database column name
                0 => 't.id',
                1 => 'added_date',
                2 => 'month',
                3 => 'year',
            );
            $filterColumn = $columns[$_POST['order'][0]['column']];
            $filterOrder = $_POST['order'][0]['dir'];
            $orderBy = $filterColumn . " " . $filterOrder;
            $condition = '1=1';
            
            $arr_months=Order::getmonths();
            if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
                $searchString = $_POST['search']['value'];
                $condition .= " and (created_date_time LIKE '%" . $searchString . "%' 
                         )";
            }
            $count = $model->count(array('condition' => $condition));
            $model = $model->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
            $recordsTotal = $count;
            $recordsFiltered = $count;
            $data['draw'] = $draw;
            $data['recordsTotal'] = $recordsTotal;
            $data['recordsFiltered'] = $recordsFiltered;
            $rowData = array();
            $m = 1;
            foreach ($model as $row) {
                $div = '';
                //if (Yii::app()->user->authorised_user == 1 || ((int) Yii::app()->user->havePermissionOn["master_brand_edit"])) {
                     //$div .=   '<button type="button"  class="btn btn-sm btn-theme" onclick="downloadconsolidatedorder('.$row[id].');" title="ALL"><i class="fa fa-download"></i></button>';
                     $div .=   '<button type="button"  class="btn btn-sm btn-theme" onclick="downloadUploaded('.$row[id].');" title="Uploaded"><i class="fa fa-download"></i></button>';
                     $div .=   ' <button type="button"  class="btn btn-sm btn-theme" onclick="deleteInitialbacklog('.$row['id'].')"><i class="fa fa-trash"></i></button>';
                //}
                
           
                $rowData[] = array($m,
                    date('d/m/Y',strtotime($row['created_date_time'])),$row['file_name'],
                    '<div class="btn-wrap text-center">' . $div . '</div>');
    
                $m++;
            }
            $data['data'] = $rowData;
            echo json_encode($data);
        }
        else{
              throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionUploadbacklog() {
        $_GET  = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
        if(count($_GET) > 0){
            $model = new UploadInitialBacklogShipment();
            Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.js' => false);
            $this->render('upload_form', array('model' => $model), false, false);
        }
        else{
              throw new CHttpException(404, 'Page not found.');
        }
        
    }
    public function actionDownloadbacklogFormat(){
        $_GET  = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
        if(count($_GET) > 0){
            $file = fopen("upload/test.csv", "w");
            $j=0;
            $list[$j++] ='GMC code!Quantity';
            $model_inventory =Inventory::model()->findAll(array('condition'=>'t.is_active="Y"'));
            foreach($model_inventory as $row){
                $list[$j++] =$row['gmc_code'].'!0';
            }
            $j++;
            foreach ($list as $line) {
                fputcsv($file, explode('!', $line));
            }
            fclose($file);
            $filename = 'upload/test.csv';
            header("Content-Type: application/csv");
            header('Content-Disposition:attachment; filename="Intial_backlog_downloadformat.csv"');
            readfile($filename);
            Yii::app()->end();
            return;
        }else{
            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionSavebacklogUpload(){
        
        $_POST  = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if(count($_POST) > 0){
            $model = new UploadInitialBacklogShipment();$other=array();
            if (isset($_POST['UploadInitialBacklogShipment'])) {
                if ((int) @$_POST['UploadInitialBacklogShipment']['id'] > 0) {
                    $id = (int) @$_POST['UploadInitialBacklogShipment']['id'];
                    $model = $model->findByPk($id);
                }else{
                    $model->created_by =Yii::app()->user->id;
                    $model->created_date_time =date('Y-m-d H:i:s');
                }
                $model->attributes = $_POST['UploadInitialBacklogShipment'];
                $file= $_POST['UploadInitialBacklogShipment']['file_name'];
                $model->file_name =$file;
                $valid= $model->validate();
                $i=0;$arr_products=[];$n=1;
                if($file!=''){
                    if (($handle = fopen("upload/intialbacklog/" . $file, "r")) !== FALSE) {
                    
                        while (($row = fgetcsv($handle)) !== FALSE) {
                            
                            if ($n > 1) {
                                $gmc_code= trim($row[0]); //gmc
                                $qty= trim($row[1]); //qty
                                $mod_inv = Inventory::model()->find(array('condition'=>'gmc_code="'.$gmc_code.'"'));
                                if(!empty($mod_inv)){
                                    $modelItems[$i] = new InitialBacklogShipmentDetails();
                                    $modelItems[$i]->upload_id =0;
                                    $modelItems[$i]->product_id = $mod_inv->id;
                                    $modelItems[$i]->gmc_code = $gmc_code;
                                    $modelItems[$i]->quantity = $qty;
                                    $modelItems[$i]->created_by = Yii::app()->user->id;
                                    $modelItems[$i]->created_date_time =date('Y-m-d H:i:s');
                                    $valid = $modelItems[$i]->validate()&& $valid;
                                    $i++;
                                    if (in_array($gmc_code,$arr_products)) {
                                        $other[] = $gmc_code. ' GMC Repeated ';
                                        $valid = false;
                                    }else{
                                        $arr_products[]=$gmc_code;
                                    }
                                }else{
                                    $other[] = 'GMC with code '.$gmc_code.' not exits';
                                    $valid = false;
                                }
                            }
                            $n++;
                            
                        }
                        fclose($handle);
                    }
                }else{
                    $other[]='File Not Uploaded';
                    $valid = false;
                }
                if ($valid) {
                    //echo '<pre>';print_r($modelItems);
                    $model->save();
                    if(!empty($modelItems)){
                        foreach($modelItems as $each){
                            $each->upload_id=$model->id;
                            $each->save(false);
                        }
                    }
                    $jsonData['status'] = 'success';
                    $jsonData['frm'] = $_POST['UploadInitialBacklogShipment'];
                    $jsonData['id'] = $model->id;
                    echo CJSON::encode($jsonData);
                } else {
                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    if(!empty($modelItems)){
                        $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                    }else{
                        $error2[] = "Please add atleast one line item";
                    }
                    $error = CJSON::encode(array_merge_recursive($error1,$error2, $other));
                    if ($error != '[]')
                        echo $error;
                }
            }
        }
        else{
              throw new CHttpException(404, 'Page not found.');
        }
        
    }
    public function actionDeleteBackLog(){
        $_POST  = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if(count($_POST)>0){
            $id = $_POST['id'];
            if($id>0){
                $model = new UploadInitialBacklogShipment();
                $model->deleteByPk($id);
                echo "success";
            } else {
                echo "fail";
            }
        }
        else{
              throw new CHttpException(404, 'Page not found.');
        }
    } 
    
    public function actionDownloadUploaded(){
        $_GET  = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
        $id = $_GET['id'];
        if(count($_GET) > 0){
            $file = fopen("upload/test.csv", "w");
            $j=0;
            $list[$j++] ='GMC code!Quantity';
            $model_inventory =Inventory::model()->findAll(array('condition'=>'t.is_active="Y"'));
            foreach($model_inventory as $row){
                $list[$j++] =$row['gmc_code'].'!0';
            }
            $j++;
            foreach ($list as $line) {
                fputcsv($file, explode('!', $line));
            }
            fclose($file);
            $filename = 'upload/test.csv';
            header("Content-Type: application/csv");
            header('Content-Disposition:attachment; filename="Intial_backlog_downloadformat.csv"');
            readfile($filename);
            Yii::app()->end();
            return;
        }else{
            throw new CHttpException(404, 'Page not found.');
        }
    }
}