<?php
/* Created By Jisha */
class InventorypriceController extends Controller
{
    public function init()
    {
        parent::init();
        $this->initAjaxCsrfToken();
    }

    // this function will work to post csrf token.
    protected function initAjaxCsrfToken()
    {

        Yii::app()->clientScript->registerScript('AjaxCsrfToken', ' $.ajaxSetup({
                         data: {"YII_CSRF_TOKEN": "' . Yii::app()->request->csrfToken . '"},
                         cache:false
                    });', CClientScript::POS_HEAD);
    }

    public function accessRules()
    {

        return array(

            array(
                'allow', // allow all users to perform 'index' and 'view' actions

                'actions' => array('login', 'error', 'logout', 'Test'),

                'users' => array('*'),

            ),

            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions

                'actions' => array(
                    'Index',  'GetList', 'Save', 'Delete','deletePriceFile','downloadpricefile','viewPrice'
                ),

                'expression' => '$user->isMember()',

            ),

            array(
                'deny', // deny all users

                'users' => array('*'),

            ),

        );
    }



    public function actionIndex()
    {

        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);

        if (count($_GET) > 0) {

            $this->render('index');
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }



    // Uncomment the following methods and override them if needed

    public function filters()
    {

        return array(

            'accessControl', // perform access control for CRUD operations

        );
    }

    public function actionviewPrice()
    {

        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);

        if (count($_GET) > 0) {

            $model = new GmcPriceUploads();

            $id = (int) Yii::app()->request->getParam('id');

            $modelDetails = array(new InventoryPrice());

            if ($id > 0) {

                $model = $model->findByPk($id);
            }

            $modelDetails = TempInventoryPrice::model()->findAll(array('condition' => 'upload_id=' . (int) $id . ' '));

            if (empty($modelDetails)) {

                $modelDetails = array(new TempInventoryPrice());
            }

            Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.js' => false);

            $this->render('view_price', array('model' => $model, 'modelDetails' => $modelDetails, 'type' => $type), false, false);
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }

    public function actionGetList()
    {

        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);

        if (count($_POST) > 0) {

            $model = new GmcPriceUploads();

            $draw = $_POST['draw'];

            $offset = $_POST['start'];

            $limit = $_POST['length'];

            $columns = array(

                // datatable column index  => database column name

                0 => 't.id',

                1 => 'upload_date',

                2 => 'from_date',

                3 => 'to_date',

                4 => 'file_name',

                5 => 'currency_code',

                6 => 'lic_percent',

                7 => 't.id'

            );

            $filterColumn = $columns[$_POST['order'][0]['column']];

            $filterOrder = $_POST['order'][0]['dir'];

            $orderBy = $filterColumn . " " . $filterOrder;

            $condition = '1=1';

            if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {

                $searchString = $_POST['search']['value'];

                $condition .= " and (currency_code LIKE '%" . $searchString . "%' OR lic_percent LIKE '%" . $searchString . "%' )";
            }

            $count = $model->count(array('condition' => $condition));

            $model = $model->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));

            $recordsTotal = $count;

            $recordsFiltered = $count;

            $data['draw'] = $draw;

            $data['recordsTotal'] = $recordsTotal;

            $data['recordsFiltered'] = $recordsFiltered;

            $rowData = array();

            $m = 1;

            foreach ($model as $row) {

                $div = '<div class="btn-wrap text-center">';
                if ($row['is_checked'] == 'Y') {
                    $div .= '<a type="button" class="btn btn-xs btn-primary" title="Download" href ="' . Yii::app()->createUrl('inventoryprice/downloadpricefile&id=' . $row['id']) . '">
                   <i class="fa fa-download"></i>
                    </a>';
                 }
                else
                {
                    $div .= '&nbsp<button type="button"  class="btn btn-xs btn-primary" onclick="deleteInventoryPriceFile(' . $row['id'] . ')"><i class="fa fa-trash"></i></button>';
                    $div .= '&nbsp<button type="button"  class="btn btn-xs btn-primary" onclick="loadPopupModal(\'inventoryprice/viewPrice&id=' . $row['id'] . '\',\'View Price Changes\',\'xl\')"><i class="fa fa-eye"></i></button>';
                }
  
                $div .= '</div>';
                $rowData[] = array(
                    $m,
                    ($row['upload_date']!="0000-00-00")?date('d/m/Y',strtotime($row['upload_date'])):"",
                    ($row['from_date']!="0000-00-00")?date('d/m/Y',strtotime($row['from_date'])):"",
                    ($row['to_date']!="0000-00-00")?date('d/m/Y',strtotime($row['to_date'])):"-",
                    $row['file_name'],
                    $row['currency_code'],
                    $row['lic_percent'],
                    $div
                );



                $m++;
            }

            $data['data'] = $rowData;

            echo json_encode($data);
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }
   
    public function actionDeletePriceFile() {
        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);
        if (!empty($_POST['id'])) { // Ensure `id` is set
            $id = (int) $_POST['id']; // Cast to integer for security
            if ($id > 0) {
                // Delete related details first
                TempInventoryPrice::model()->deleteAll('upload_id=:refer_id', array(':refer_id' => $id));
    
                // Find the main CreditHold record
                $model = GmcPriceUploads::model()->findByPk($id);
    
                if ($model !== null) { // Ensure record exists before accessing properties
                    $locfile = "upload/price/" . $model->file_name;
    
                    // Delete the main CreditHold record
                    if ($model->deleteByPk($id)) {
                        // Delete the file if it exists
                        if (!empty($model->file_name) && file_exists($locfile)) {
                            if (unlink($locfile)) {
                                echo "success";
                            } else {
                                echo "fail: unable to delete file.";
                            }
                        } else {
                            echo "success"; // File doesn't exist, but deletion is still successful
                        }
                    } else {
                        echo "fail: unable to delete record.";
                    }
                } else {
                    echo "fail: record not found.";
                }
            } else {
                echo "fail: invalid ID.";
            }
        } else {
            throw new CHttpException(400, 'Bad Request: ID is required.');
        }
    }
    
    public function actiondownloadpricefile()
    {
         $id = (int) Yii::app()->request->getParam('id');
        $arr_price = GmcPriceUploads::model()->findByPk($id);
        $file = $arr_price->file_name;
        $arr_doc_val = explode(',', $arr_price->file_name);
       $path = Yii::getPathOfAlias('webroot') . "/upload/price/" . $file;
    
        header("Content-type:application/octet-stream"); //for txt file
        header("Content-Type: application/download");
        //header('Content-Type:text/plain; charset=ISO-8859-15');
        //if you want to read text file using text/plain header
        header('Content-Disposition: attachment; filename="' . basename($path) . '"');
        header('Content-Length: ' . filesize($path));
        readfile($path);
        Yii::app()->end();
    }

}
