<?php
require_once(__DIR__ . '/../../extensions/Spreadsheet/autoload.php'); 
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\Cell\Cell;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use PhpOffice\PhpSpreadsheet\Style\Border;
use PhpOffice\PhpSpreadsheet\Style\Alignment;
class OrdertakingreportController extends Controller
{
	public function init()
	{
		parent::init();
		$this->initAjaxCsrfToken();
	}

	// this function will work to post csrf token.
	protected function initAjaxCsrfToken()
	{
		Yii::app()->clientScript->registerScript('AjaxCsrfToken', ' $.ajaxSetup({
             data: {"' . Yii::app()->request->csrfToken . '": "' . Yii::app()->request->csrfToken . '"},
             cache:false
        });', CClientScript::POS_HEAD);
	}

	public function accessRules()
	{
		return array(
			array(
				'allow', // allow all users to perform 'index' and 'view' actions
				'actions' => array('login', 'error', 'logout'),
				'users' => array('*'),
			),
			array(
				'allow', // allow authenticated user to perform 'create' and 'update' actions
				'actions' => array('Index','Create','DownloadErrorCsv','CheckErrorsGW','GetOrderTakingList','SaveUpload','UploadDocuments','DeleteOrderTakingReport','SaveUploadNext','ViewOrder',
				'Report','Add','GetList','Save','DownloadOrderTakingReport'
                ),
				'expression' => '$user->isMember()',
			),
			array(
				'deny', // deny all users
				'users' => array('*'),
			),
		);
	}

	public function actionIndex()
	{
		//if (isset(Yii::app()->user->havePermissionOn['master_category_type_name_view']) || Yii::app()->user->authorised_user == 1) {
		$_GET  = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
		if (count($_GET) > 0) {
			$this->render('index');
		} else {
			throw new CHttpException(404, 'Page not found.');
		}
		/*} else {
			throw new CHttpException(401, 'Unauthorized Access');
		}*/
	}
	public function actionCreate() {

        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_SPECIAL_CHARS);
        if (count($_GET) > 0) {
            $save_type=$_GET['save_type'];
            $model = new OtReportGlobalUpload();
            $modelHistory = $model->find();
            Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.js' => false);
            $this->render('upload_form', array('model' => $model,'save_type'=>$save_type), false, false);
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }
    
    public function actionViewOrder() {

        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_SPECIAL_CHARS);
        if (count($_GET) > 0) {
            $id=$_GET['id'];
            Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.js' => false);
            $this->render('view_details', array('id'=>$id), false, false);
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionGetOrderTakingList() {
        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if (count($_POST) > 0) {

            $model = new OtReportGlobalUpload();

            $draw = $_POST['draw'];

            $offset = $_POST['start'];

            $limit = $_POST['length'];

            $columns = array(
                // datatable column index  => database column name

                0 => 't.id',
                1 => 't.from_year',
                2 => 't.to_year',
                2 => 't.ot_type',
            );

            $filterColumn = $columns[$_POST['order'][0]['column']];

            $filterOrder = $_POST['order'][0]['dir'];

            $orderBy = $filterColumn . " " . $filterOrder;

            $condition = '1=1';
            
            if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {

                $searchString = $_POST['search']['value'];

                $condition .= " and (from_year LIKE '%" . $searchString . "%' OR to_year LIKE '%" . $searchString . "%')";
            }

            $count = $model->count(array('condition' => $condition));

            $model = $model->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));

            //$count =$model->count();

            $recordsTotal = $count;

            $recordsFiltered = $count;

            $data['draw'] = $draw;

            $data['recordsTotal'] = $recordsTotal;

            $data['recordsFiltered'] = $recordsFiltered;

            $rowData = array();

            $m = 1;
            $arr_type=['Q'=>'Quantity','A'=>'Amount'];
            foreach ($model as $row) {

                $div = '';

                /*if (Yii::app()->user->authorised_user == 1 || ((int) Yii::app()->user->havePermissionOn["orders_view"])) {

                    $div .= ' <button class="btn btn-primary btn-xs" title="View Order" onclick="vieworder(' . $row['id'] . ');"><i class="fa fa-eye"></i></button>';
                }*/
                
                if($row['is_completed']=="Y"){
                    $div .= ' <button class="btn btn-primary btn-xs" title="View Order" onclick="vieworder(' . $row['id'] . ');"><i class="fa fa-eye"></i></button>';
                    
                }elseif($row['is_checked']=="Y"){
                    if($row['have_errors']=="Y"){
                        $div .= CHtml::link(
                            'Download log',
                            ['ordertakingreport/DownloadErrorCsv', 'id' => $row['ot_file_name']],
                            [ 'style' => 'border: 1px solid #686869; padding: 2px 10px; border-radius: 10px; font-size: 10px; background: #a1a1a1; color: #fff;']
                        );
                    }
                    $div .= '<button type="button" class="btn btn-xs btn-primary" title="Upload Next" onclick="SaveUploadNext(' . $row['id'] .');">
                        <i class="fa fa-arrow-up"></i>
                        </button>';
                }else{
                    $div .= '&nbsp<button type="button"  class="btn btn-xs btn-primary" title="Check Errors" onclick="CheckErrorsGW(' . $row['id'] . ')"><i class="fa fa-retweet"></i></button>';
                }
                //will remove in live
                $div .= '&nbsp<button type="button"  class="btn btn-xs btn-primary" onclick="DeleteOrderTakingReport(' . $row['id'] . ')"><i class="fa fa-trash"></i></button>';
                $rowData[] = array($m,$row['from_year'], $row['to_year'],$arr_type[$row['ot_type']],$row['last_entry'].' out of '.$row['total_entries'],
                    '<div class="btn-wrap text-center">' . $div . '</div>');

                $m++;
            }

            $data['data'] = $rowData;

            echo json_encode($data);
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionSaveUpload(){
        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        if (count($_POST) > 0) {
            $model = new OtReportGlobalUpload();
            $other = array();

            if (isset($_POST['OtReportGlobalUpload'])) {
                if ((int) @$_POST['OtReportGlobalUpload']['id'] > 0) {
                    $id = (int) @$_POST['OtReportGlobalUpload']['id'];
                    $model = $model->findByPk($id);                }
                $model->created_by = Yii::app()->user->id;
                $model->created_date_time = date('Y-m-d H:i:s');
                $model->attributes = $_POST['OtReportGlobalUpload'];
                $file = $_POST['OtReportGlobalUpload']['ot_file_name'];
                $model->ot_file_name = $file;
                $valid = $model->validate();
                $mod_his = OtReportGlobalUpload::model()->find(array('condition' => ' from_year = "' . $_POST['OtReportGlobalUpload']['from_year'] . '" and to_year	 = "' . $_POST['OtReportGlobalUpload']['to_year	'] . '" AND ot_type="' . $_POST['OtReportGlobalUpload']['ot_type'] . '"'));
                $mod_his_compl = OtReportGlobalUpload::model()->find(array('condition' => 'is_completed="N" '));
                if(!empty($mod_his_compl)){
                    $other[] = 'Please Complete Uploading the previous file before adding New';
                    $valid = false; 
                }
                if (!empty($mod_his)) {
                    $other[] = 'Already added Data For this Period';
                    $valid = false;
                }
                if ($file != '') {
                    $locfile = "upload/ordertakingreport/" . $file;
                    $lines = file($locfile);
                    if ($lines !== false) {
                        $lineCount =count($lines);
                    } else {
                        $other[] = 'Error: Unable to read the file.';
                        $valid = false;
                    }
                    $totalrows=$lineCount;
                    
                }else{
                    $other[] = 'File Not Uploaded';
                    $valid = false;
                }
                if ($valid) {
                    $model->last_entry=0;
                    $model->total_entries=$totalrows;
                    $model->to_year = (int)$model->from_year+1;
                    $model->save();
                    $jsonData['status'] = 'success';
                    $jsonData['completed'] = $model->is_completed;
                    $jsonData['last_entry'] = $model->last_entry;
                    $jsonData['msg'] = "GlobalUpload File Uploaded. Please Check For Errors and Upload";
                    $jsonData['id'] = $model->id;
                    echo CJSON::encode($jsonData);
                } else {
                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    $error = CJSON::encode(array_merge_recursive($error1, $other));
                    if ($error != '[]')
                        echo $error;
                }
            }
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }
    
    public function actionCheckErrorsGW() {
        $model = new OtReportGlobalUpload();
        $other = [];
        $valid = true;
        $arr_err_list = [];
    
        if (!isset($_REQUEST['id']) || (int)$_REQUEST['id'] <= 0) {
            echo CJSON::encode(['error' => 'Invalid Id']);
            return;
        }
    
        $id = (int)$_REQUEST['id'];
        $model = $model->findByPk($id);
        if (!$model) {
            echo CJSON::encode(['error' => 'Global Upload File not found.']);
            return;
        }
    
        $file = $model->ot_file_name;
        if (empty($file)) {
            echo CJSON::encode(['error' => 'File Not Uploaded']);
            return;
        }
    
        $locfile = "upload/ordertakingreport/" . $file;
        $error_url = "upload/ordertakingreport/error/" . $file;
        
        // Check if file exists before processing
        if (!file_exists($locfile) || !is_readable($locfile)) {
            echo CJSON::encode(['error' => 'Invalid File']);
            return;
        }
        // Fetch all distributors and inventory items in one query
        $distributorMap = array_flip(array_column(Distributers::model()->findAll(), 'alias_2_name'));
        $distributor2Map = array_flip(array_column(Distributers::model()->findAll(), 'alias_3_name'));
        $inventoryMap = array_flip(array_column(Inventory::model()->findAll(['condition' => '(is_active="Y" OR is_active="D")']), 'gmc_code'));
    
    
        $fileObj = new SplFileObject($locfile);
        $fileObj->setFlags(SplFileObject::READ_CSV);
    
        $lineNumber = 0;
        foreach ($fileObj as $row) {
            $lineNumber++;
            if ($lineNumber < 56|| empty($row)) continue; // Skip header row & empty rows
    
            $gmc_code = trim($row[2]); // GMC Code
            $supplier_code = trim($row[4]); // Supplier Code
            if (!isset($distributorMap[$supplier_code])&&!isset($distributor2Map[$supplier_code])) {
                $arr_err_list[] = "Distributor Not Exists: $supplier_code in line $lineNumber";
            }
            if (!isset($inventoryMap[$gmc_code])) {
                $arr_err_list[] = "GMC with code $gmc_code and model $model_no not exists in line $lineNumber";
            }
        }
    
        if (!empty($arr_err_list)) {
            $model->have_errors="Y";
            $model->is_checked="Y";
            $model->save(false);
            file_put_contents($error_url, implode("\n", $arr_err_list)); // Write errors in one go
    
            echo CJSON::encode([
                'error_url' => $error_url,
                'msg' => 'Have errors. Fix Errors /Continue to Upload',
                'filename' => $file,
                'link' => CHtml::link(
                    'Download log',
                    ['ordertakingreport/DownloadErrorCsv', 'id' => $file],
                    ['target' => '_blank', 'style' => 'border: 1px solid #686869; padding: 2px 10px; border-radius: 10px; font-size: 10px; background: #a1a1a1; color: #fff;']
                ),
                'status' => 'success',
                'id' => $model->id
            ]);
        } else {
            $model->have_errors="N";
            $model->is_checked="Y";
            $model->save(false);
            echo CJSON::encode([
                'msg' => 'No errors. Continue to Upload',
                'status' => 'success',
                'id' => $model->id
            ]);
        }
    }
    public function actionDownloadErrorCsv() {
        $file_name = $event_id = Yii::app()->request->getParam('id');
        //$error_url = Yii::app()->basePath . '../upload/ordertakingreport/error/'. $file_name;
        $error_url ='upload/ordertakingreport/error/'. $file_name;
        return Yii::app()->getRequest()->sendFile('log.csv', @file_get_contents($error_url));
    }
    public function actionDeleteOrderTakingReport() {
        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);
        if (!empty($_POST['id'])) { // Ensure `id` is set
            $id = (int) $_POST['id']; // Cast to integer for security
            if ($id > 0) {
                // Delete related details first
                OtReportGlobalUploadDetails::model()->deleteAll('upload_id=:refer_id', array(':refer_id' => $id));
    
                // Find the main CreditHold record
                $model = OtReportGlobalUpload::model()->findByPk($id);
    
                if ($model !== null) { // Ensure record exists before accessing properties
                    $locfile = "upload/ordertakingreport/" . $model->ot_file_name;
    
                    // Delete the main CreditHold record
                    if ($model->deleteByPk($id)) {
                        // Delete the file if it exists
                        if (!empty($model->ot_file_name) && file_exists($locfile)) {
                            if (unlink($locfile)) {
                                echo "success";
                            } else {
                                echo "fail: unable to delete file.";
                            }
                        } else {
                            echo "success"; // File doesn't exist, but deletion is still successful
                        }
                    } else {
                        echo "fail: unable to delete record.";
                    }
                } else {
                    echo "fail: record not found.";
                }
            } else {
                echo "fail: invalid ID.";
            }
        } else {
            throw new CHttpException(400, 'Bad Request: ID is required.');
        }
    }
    
    public function actionSaveUploadNext(){
        $_POST = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
        if (count($_POST) > 0) {
            $model = new OtReportGlobalUpload();
            $other = array();
            $flag_stop ='N';
            $last_entry=55;$total_entry=0;$limit_entry =0;
            
            if ((int) @$_REQUEST['id'] > 0) {
                $id = (int) @$_REQUEST['id'];
                $model = $model->findByPk($id); 
                $last_entry=(int)$model->last_entry;
                $total_entry=(int)$model->total_entries;
                $limit_entry = min($last_entry + 5000, $total_entry);
                $file = $model->ot_file_name;
                $valid = true;
            }
            if ($file != '') {
                $handle = fopen("upload/ordertakingreport/" . $file, "r");
                stream_filter_append($handle, "convert.iconv.UTF-8/UTF-8//IGNORE", STREAM_FILTER_READ);
                
                // Fetch data in one query
                $distributors = Distributers::model()->findAll(['select' => 'id, alias_2_name,alias_3_name, region_id,distributer_name']);
                $inventoryItems = Inventory::model()->findAll(['select' => 'id, gmc_code, product_category_id']);
    
                // Create lookup maps
                $distributorMap = array_column($distributors, null, 'alias_2_name');
                $distributor2Map = array_column($distributors, null, 'alias_3_name');
                $inventoryMap = array_column($inventoryItems, null, 'gmc_code');
    
                $n = 1;
                $batchData = [];
                

                while (($row = fgetcsv($handle)) !== FALSE) {
                    $month = 4;
                    $year = $model->from_year;
                    if ($n > $last_entry && $flag_stop == 'N') {
                        $gmc_code = trim($row[2]);
                        $supplier_code = trim($row[4]);
                        if ((isset($distributorMap[$supplier_code])||isset($distributor2Map[$supplier_code])) && isset($inventoryMap[$gmc_code])) {
                            $distributor = isset($distributorMap[$supplier_code])?$distributorMap[$supplier_code]:$distributor2Map[$supplier_code];
                            $inventory = $inventoryMap[$gmc_code];
    
                            for ($k = 6; $k < 18; $k++) {
                                $qty = (int) filter_var(trim($row[$k]), FILTER_SANITIZE_NUMBER_INT);
                                if($qty>0){
                                    $batchData[] = [
                                        'upload_id' => $model->id,
                                        'product_id' => $inventory['id'],
                                        'product_category_id' => $inventory['product_category_id'],
                                        'distributor_id' => $distributor['id'],
                                        'distributer_name' => $distributor['distributer_name'],
                                        'region_id' => $distributor['region_id'],
                                        'gmc' => $gmc_code,
                                        'ot_month' => $month,
                                        'ot_year' => $year,
                                        'quantity' => $qty,
                                    ];
                                }
                                $month++;
                                if ($month == 13) {
                                    $month = 1;
                                    $year = $model->to_year;
                                }
                                
                            }
                        }
                        if (count($batchData) >= 5000) {
                            $this->bulkInsert('ymh_ot_report_global_upload_details', $batchData);
                            $batchData = [];
                        }
    
                        if ($n >= $limit_entry) {
                            $flag_stop = 'Y';
                        }
                    }
                    $n++;
                }
                fclose($handle);
    
                if (!empty($batchData)) {
                    $this->bulkInsert('ymh_ot_report_global_upload_details', $batchData);
                }
                // Count rows without loading the file into memory
                $totalrows = count(file("upload/ordertakingreport/" . $file, FILE_SKIP_EMPTY_LINES));

            } else {
                $other[] = 'File Not Uploaded';
                $valid = false;
            }

            if ($valid) {
                $model->last_entry = $limit_entry;
                $model->total_entries = $totalrows;
                $model->is_completed = ($model->last_entry >= $model->total_entries) ? 'Y' : 'N';
                $model->save();
    
                echo CJSON::encode([
                    'status' => 'success',
                    'completed' => $model->is_completed,
                    'last_entry' => $model->last_entry,
                    'msg' => "OtReportGlobalUpload Data Upto " . $model->last_entry . " Uploaded. Press Next to Continue Upload",
                    'id' => $model->id
                ]);
            } else {
                echo CJSON::encode([
                    'status' => 'failed',
                    'msg' => array_merge_recursive($other, ["Please add at least one line item"])
                ]);
            }
        } else {
            throw new CHttpException(404, 'Page not found.');
        }
    }
    /**
 * Bulk insert function
 */
    
    private function bulkInsert($tableName, $data) {
        if (empty($data)) {
            return;
        }
    
        $columns = array_keys($data[0]); // Get column names from first record
        $values = [];
        $params = [];
    
        foreach ($data as $index => $row) {
            $placeholders = [];
            foreach ($row as $key => $value) {
                $paramName = ":{$key}_{$index}";
                $placeholders[] = $paramName;
                $params[$paramName] = $value;
            }
            $values[] = "(" . implode(",", $placeholders) . ")";
        }
    
        $sql = "INSERT INTO {$tableName} (" . implode(",", $columns) . ") VALUES " . implode(",", $values);
        
        Yii::app()->db->createCommand($sql)->execute($params);
    }
    public function actionReport()
	{
		//if (isset(Yii::app()->user->havePermissionOn['master_category_type_name_view']) || Yii::app()->user->authorised_user == 1) {
		$_GET  = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
		if (count($_GET) > 0) {
			$this->render('report');
		} else {
			throw new CHttpException(404, 'Page not found.');
		}
		/*} else {
			throw new CHttpException(401, 'Unauthorized Access');
		}*/
	}
	public function actionAdd() {

        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_SPECIAL_CHARS);
        if (count($_GET) > 0) {
            $model = new OrderTakingReport();
            Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.js' => false);
            $this->render('create', array('model' => $model), false, false);
        } else {
            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionGetList() {

        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

        if (count($_POST) > 0) {

            $model = new OrderTakingReport();

            $draw = $_POST['draw'];

            $offset = $_POST['start'];

            $limit = $_POST['length'];

            $columns = array(
                // datatable column index  => database column name

                0 => 't.id',
                1 => 't.ot_month',
                2 => 't.ot_year',
            );

            $filterColumn = $columns[$_POST['order'][0]['column']];

            $filterOrder = $_POST['order'][0]['dir'];

            $orderBy = $filterColumn . " " . $filterOrder;

            $condition = '1=1';

            $arr_months = Order::getmonths();

            if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {

                $searchString = $_POST['search']['value'];

                $condition .= " and (ot_month LIKE '%" . $searchString . "%' OR ot_year LIKE '%" . $searchString . "%')";
            }

            $count = $model->count(array('condition' => $condition));

            $model = $model->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));

            //$count =$model->count();

            $recordsTotal = $count;

            $recordsFiltered = $count;

            $data['draw'] = $draw;

            $data['recordsTotal'] = $recordsTotal;

            $data['recordsFiltered'] = $recordsFiltered;

            $rowData = array();

            $m = 1;

            foreach ($model as $row) {

                $div = '';
                $div .= '<button type="button" class="btn btn-xs btn-primary" title="Order Taking Report" onclick="window.open($(\'#liveSite\').val() + \'index.php?r=ordertakingreport/DownloadOrderTakingReport&ot_report_id=' . $row['id'] . '\', \'_blank\');">
                <i class="fa fa-file-excel-o"></i>
                </button>';
                $rowData[] = array($m, $arr_months[(int) $row['ot_month']], $row['ot_year'],
                    '<div class="btn-wrap text-center">' . $div . '</div>');

                $m++;
            }

            $data['data'] = $rowData;

            echo json_encode($data);
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }
     //save inventory Report
    public function actionSave(){
        $_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);
        if (count($_POST) > 0) {
            $model = new OrderTakingReport();
            $other = array();
            if (isset($_POST['OrderTakingReport'])) {
                if ((int) @$_POST['OrderTakingReport']['id'] > 0) {
                    $id = (int) @$_POST['OrderTakingReport']['id'];
                    $model = $model->findByPk($id); 
                }
                $model->created_by = Yii::app()->user->id;
                $model->created_date_time = date('Y-m-d H:i:s');
                $model->attributes = $_POST['OrderTakingReport'];
                $valid = $model->validate();
                $arr_months = Order::getmonths();
                
                if ($valid) {
                    $model->save();
                    $jsonData['status'] = 'success';
                    $jsonData['frm'] = $_POST['OrderTakingReport'];
                    $jsonData['id'] = $model->id;
                    echo CJSON::encode($jsonData);
                } else {

                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    $error = CJSON::encode(array_merge_recursive($error1, $other));
                    if ($error != '[]')
                        echo $error;
                }
            }
        } else {

            throw new CHttpException(404, 'Page not found.');
        }
    }
    public function actionDownloadOrderTakingReport()
    {
        $ot_report_id = $_REQUEST['ot_report_id'];
        $_GET = filter_input_array(INPUT_GET, FILTER_SANITIZE_SPECIAL_CHARS);
        
        if (count($_GET) > 0) {
            
            // Helper function to populate a row with data
            function setData($worksheet, $rowNumber, $data) {
                $column = 'A';
                foreach ($data as $value) {
                    $worksheet->setCellValue("{$column}{$rowNumber}", $value);
                    $column++;
                }
            }
    
            // Helper function to set cell background color
            function setFillColor($worksheet, $range, $color) {
                $worksheet->getStyle($range)->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB($color);
            }
            // Retrieve data from the database
            $arr_month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Oct", "Nov", "Dec"];
            $modelOrderTaking = new OrderTakingReport();
            $modelOrderTaking = $modelOrderTaking->findByPK((int)$ot_report_id);
            $ModDistributers = new Distributers();
            $ModDistributers = $ModDistributers->with('region_det')->findAll(['order'=>'region_det.sort_order asc']);
            
            // Create new spreadsheet
            $spreadsheet = new Spreadsheet();
            $activeWorksheet = $spreadsheet->getActiveSheet();
            
            $current_year = $modelOrderTaking->ot_year; // Get the current year dynamically
            $base_year = $current_year - 5; // Dynamically determine the base financial year
            
            // Generate financial years dynamically
            $fin_year1 = substr($base_year, -2) . '/' . substr(($base_year + 1), -2);
            $fin_year2 = substr(($base_year + 1), -2) . '/' . substr(($base_year + 2), -2);
            $fin_year3 = substr(($base_year + 2), -2) . '/' . substr(($base_year + 3), -2);
            $fin_year4 = substr(($base_year + 3), -2) . '/' . substr(($base_year + 4), -2);
            $fin_4='';
            // Set the title in merged cells
            $activeWorksheet->mergeCells('A1:L1');
            $activeWorksheet->setCellValue('A1', "Order Taking Summary Report");
            $activeWorksheet->mergeCells('A2:L2');
            //$activeWorksheet->setCellValue('A2', "01-".$arr_month[$modelOrderTaking['ot_month']-1]."-".$modelOrderTaking['ot_year']);
            $activeWorksheet->getStyle('A1:L1')->getFont()->setBold(true);
            $activeWorksheet->getStyle('A1')->getAlignment()->setVertical(\PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_CENTER);
            // Set font size to 16 for cell A1
            $activeWorksheet->getStyle('A1')->getFont()->setSize(16);
            $activeWorksheet->getStyle('A2')->getFont()->setSize(16);
            $activeWorksheet->mergeCells('A3:A4');
            $activeWorksheet->mergeCells('B3:B4');
            $activeWorksheet->mergeCells('C3:C4');
            // Add filter for row 3
            $activeWorksheet->setAutoFilter('A4:BH4');
            // Set width for column A and B individually
            $activeWorksheet->getColumnDimension('A')->setWidth(11);
            $activeWorksheet->getColumnDimension('B')->setWidth(19);
            // Hide the "C" column (Alias)--start
            $activeWorksheet->getColumnDimension('C')->setVisible(false);
            // Hide the "C" column (Alias)--end
            $activeWorksheet->setCellValue('A3', "REGION");
            $activeWorksheet->setCellValue('B3', "DISTRIBUTOR NAME");
            $activeWorksheet->setCellValue('C3', "Alias2");
            $activeWorksheet->mergeCells('D3:G3');
            $activeWorksheet->setCellValue('D3', "Result");
            setFillColor($activeWorksheet, "A3:C4", '92D050');
            $activeWorksheet->setCellValue('D4', "FY".$fin_year1);
            $activeWorksheet->setCellValue('E4', "FY".$fin_year2);
            $activeWorksheet->setCellValue('F4', "FY".$fin_year3);
            $activeWorksheet->setCellValue('G4', "FY".$fin_year4);
            
            // Freeze the pane at cell J4
            $activeWorksheet->freezePane('J4'); 
            // Set width for column A and B individually
            //$activeWorksheet->getColumnDimension('A')->setWidth(21.83);
            //$activeWorksheet->getColumnDimension('B')->setWidth(19);
            
            // Set the height of row 1 to 25
            $activeWorksheet->getRowDimension(1)->setRowHeight(25);
            $rowNumber=5;
            foreach($ModDistributers as $eachdistr){
                $modelD = new OtReportGlobalUploadDetails();
                $cond1='distributor_id= '.(int)$eachdistr->id.' AND ((ot_year='.$base_year.' AND ot_month>3) OR(ot_year='.($base_year+1).' AND ot_month<3)) ';
                $cond2='distributor_id= '.(int)$eachdistr->id.' AND ((ot_year='.($base_year+1).' AND ot_month>3) OR(ot_year='.($base_year+2).' AND ot_month<3)) ';
                $cond3='distributor_id= '.(int)$eachdistr->id.' AND ((ot_year='.($base_year+2).' AND ot_month>3) OR(ot_year='.($base_year+3).' AND ot_month<3)) ';
                $cond4='distributor_id= '.(int)$eachdistr->id.' AND ((ot_year='.($base_year+3).' AND ot_month>3) OR(ot_year='.($base_year+4).' AND ot_month<3)) ';
                $Q1 = $modelD->find(['select'=>'SUM(quantity) AS quantity','condition'=>$cond1])->quantity;
                $Q2 = $modelD->find(['select'=>'SUM(quantity) AS quantity','condition'=>$cond2])->quantity;
                $Q3 = $modelD->find(['select'=>'SUM(quantity) AS quantity','condition'=>$cond3])->quantity;
                $Q4 = $modelD->find(['select'=>'SUM(quantity) AS quantity','condition'=>$cond4])->quantity;
                $columnHeaders = [
                    'A' => $eachdistr->region_det->region_name,
                    'B' => $eachdistr->distributer_name,
                    'C' => $eachdistr->alias_2_name,
                    'D' => ($Q1>0)?$Q1.' PCS':'',
                    'E' => ($Q2>0)?$Q2.' PCS':'',
                    'F' => ($Q3>0)?$Q3.' PCS':'',
                    'G' => ($Q4>0)?$Q4.' PCS':'',
                    'H' => '',
                    'I' => '',
                    'J' => '',
                    'K' => '',
                    'L' => '',
                    'M' => '',
                ];
                setData($activeWorksheet, $rowNumber, $columnHeaders);
                $rowNumber++;
            }
            // Set headers for file download
            $writer = new Xlsx($spreadsheet);
            $fileName = 'OrderTakingSummaryReport_' . date('Ymd') . '.xlsx';
            header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
            header('Content-Disposition: attachment; filename="' . $fileName . '"');
            header('Cache-Control: max-age=0');
    
            // Save the spreadsheet to output
            $writer->save('php://output');
            Yii::app()->end();
        } else {
            throw new CHttpException(404, 'Page not found.');
        }
    }
}
