<?php

/**
 * This is the model class for table "{{credit_hold}}".
 *
 * The followings are the available columns in table '{{credit_hold}}':
 * @property integer $id
 * @property string $ch_year
 * @property integer $ch_month
 * @property string $ch_file_name
 * @property integer $uploaded_by
 * @property string $uploaded_date_time
 */
class CreditHold extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{credit_hold}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('ch_year, ch_month, ch_file_name, uploaded_by, uploaded_date_time', 'required'),
			array('ch_month, uploaded_by', 'numerical', 'integerOnly'=>true),
			array('ch_file_name', 'length', 'max'=>255),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, ch_year, ch_month, ch_file_name, uploaded_by, uploaded_date_time', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'ch_year' => 'Ch Year',
			'ch_month' => 'Ch Month',
			'ch_file_name' => 'Ch File Name',
			'uploaded_by' => 'Uploaded By',
			'uploaded_date_time' => 'Uploaded Date Time',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('ch_year',$this->ch_year,true);
		$criteria->compare('ch_month',$this->ch_month);
		$criteria->compare('ch_file_name',$this->ch_file_name,true);
		$criteria->compare('uploaded_by',$this->uploaded_by);
		$criteria->compare('uploaded_date_time',$this->uploaded_date_time,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return CreditHold the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
