<?php

/**
 * This is the model class for table "{{inventory_report}}".
 *
 * The followings are the available columns in table '{{inventory_report}}':
 * @property integer $id
 * @property integer $inv_month
 * @property string $inv_year
 * @property integer $stock_upload_id
 * @property integer $baseinventory_upload_id
 * @property integer $budget_upload_id
 * @property integer $created_by
 * @property string $created_date_time
 */
class InventoryReport extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{inventory_report}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('inv_month, inv_year', 'required'),
			array('inv_month, stock_upload_id, baseinventory_upload_id, budget_upload_id, created_by', 'numerical', 'integerOnly'=>true),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, inv_month, inv_year, stock_upload_id, baseinventory_upload_id, budget_upload_id, created_by, created_date_time', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'inv_month' => 'Inv Month',
			'inv_year' => 'Inv Year',
			'stock_upload_id' => 'Stock Upload',
			'baseinventory_upload_id' => 'Baseinventory Upload',
			'budget_upload_id' => 'Budget Upload',
			'created_by' => 'Created By',
			'created_date_time' => 'Created Date Time',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('inv_month',$this->inv_month);
		$criteria->compare('inv_year',$this->inv_year,true);
		$criteria->compare('stock_upload_id',$this->stock_upload_id);
		$criteria->compare('baseinventory_upload_id',$this->baseinventory_upload_id);
		$criteria->compare('budget_upload_id',$this->budget_upload_id);
		$criteria->compare('created_by',$this->created_by);
		$criteria->compare('created_date_time',$this->created_date_time,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return InventoryReport the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
