<?php

/**
 * This is the model class for table "{{inventory_report_budget_upload}}".
 *
 * The followings are the available columns in table '{{inventory_report_budget_upload}}':
 * @property integer $id
 * @property string $inv_year
 * @property integer $inv_month
 * @property string $budget_file
 * @property integer $uploaded_by
 * @property string $uploaded_date_time
 */
class InventoryReportBudgetUpload extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{inventory_report_budget_upload}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('inv_year, inv_month, budget_file, uploaded_by, uploaded_date_time', 'required'),
			array('inv_month, uploaded_by', 'numerical', 'integerOnly'=>true),
			array('budget_file', 'length', 'max'=>255),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, inv_year, inv_month, budget_file, uploaded_by, uploaded_date_time', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'inv_year' => 'Inv Year',
			'inv_month' => 'Inv Month',
			'budget_file' => 'Budget File',
			'uploaded_by' => 'Uploaded By',
			'uploaded_date_time' => 'Uploaded Date Time',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('inv_year',$this->inv_year,true);
		$criteria->compare('inv_month',$this->inv_month);
		$criteria->compare('budget_file',$this->budget_file,true);
		$criteria->compare('uploaded_by',$this->uploaded_by);
		$criteria->compare('uploaded_date_time',$this->uploaded_date_time,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return InventoryReportBudgetUpload the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
