<?php

/**
 * This is the model class for table "{{inventory_report_budget_upload_details}}".
 *
 * The followings are the available columns in table '{{inventory_report_budget_upload_details}}':
 * @property integer $id
 * @property integer $inv_report_id
 * @property integer $inv_month
 * @property string $inv_year
 * @property integer $product_category_id
 * @property string $product_category
 * @property string $budget_amount
 * @property integer $created_by
 * @property string $created_date_time
 * @property integer $updated_by
 * @property string $updated_date_time
 */
class InventoryReportBudgetUploadDetails extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{inventory_report_budget_upload_details}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('inv_report_id, inv_month, inv_year, product_category_id, product_category, budget_amount', 'required'),
			array('inv_report_id, inv_month, product_category_id, created_by, updated_by', 'numerical', 'integerOnly'=>true),
			array('product_category', 'length', 'max'=>255),
			array('budget_amount', 'length', 'max'=>15),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, inv_report_id, inv_month, inv_year, product_category_id, product_category, budget_amount, created_by, created_date_time, updated_by, updated_date_time', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'inv_report_id' => 'Inv Report',
			'inv_month' => 'Inv Month',
			'inv_year' => 'Inv Year',
			'product_category_id' => 'Product Category',
			'product_category' => 'Product Category',
			'budget_amount' => 'Budget Amount',
			'created_by' => 'Created By',
			'created_date_time' => 'Created Date Time',
			'updated_by' => 'Updated By',
			'updated_date_time' => 'Updated Date Time',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('inv_report_id',$this->inv_report_id);
		$criteria->compare('inv_month',$this->inv_month);
		$criteria->compare('inv_year',$this->inv_year,true);
		$criteria->compare('product_category_id',$this->product_category_id);
		$criteria->compare('product_category',$this->product_category,true);
		$criteria->compare('budget_amount',$this->budget_amount,true);
		$criteria->compare('created_by',$this->created_by);
		$criteria->compare('created_date_time',$this->created_date_time,true);
		$criteria->compare('updated_by',$this->updated_by);
		$criteria->compare('updated_date_time',$this->updated_date_time,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return InventoryReportBudgetUploadDetails the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
