<?php

/**
 * This is the model class for table "{{ot_report_global_upload}}".
 *
 * The followings are the available columns in table '{{ot_report_global_upload}}':
 * @property integer $id
 * @property string $from_year
 * @property string $to_year
 * @property string $ot_file_name
 * @property string $ot_type
 * @property string $status
 * @property integer $created_by
 * @property string $created_date_time
 */
class OtReportGlobalUpload extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{ot_report_global_upload}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('from_year,ot_file_name, created_by, created_date_time', 'required'),
			array('created_by', 'numerical', 'integerOnly'=>true),
			array('ot_file_name,to_year', 'length', 'max'=>255),
			array('ot_type', 'length', 'max'=>1),
			array('status', 'length', 'max'=>2),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, from_year, to_year, ot_file_name, ot_type, status, created_by, created_date_time', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'from_year' => 'From Year',
			'to_year' => 'To Year',
			'ot_file_name' => 'Ot File Name',
			'ot_type' => 'Ot Type',
			'status' => 'Status',
			'created_by' => 'Created By',
			'created_date_time' => 'Created Date Time',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('from_year',$this->from_year,true);
		$criteria->compare('to_year',$this->to_year,true);
		$criteria->compare('ot_file_name',$this->ot_file_name,true);
		$criteria->compare('ot_type',$this->ot_type,true);
		$criteria->compare('status',$this->status,true);
		$criteria->compare('created_by',$this->created_by);
		$criteria->compare('created_date_time',$this->created_date_time,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return OtReportGlobalUpload the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
	
	 public static function getyear(){
            $arr_month = array("2020"=>"2020-2021","2021"=>"2021-2022", "2022"=>"2022-2023","2023"=>"2023-2024","2024"=>"2024-2025" ,"2025"=>"2025-2026","2026"=>"2026-2027" ,"2027"=>"2027-2028","2028"=>"2028-2029","2029"=>"2029-2030","2030"=>"2030-2031");
            return $arr_month;
        } 
}
