<?php

/**
 * This is the model class for table "{{ot_report_global_upload_details}}".
 *
 * The followings are the available columns in table '{{ot_report_global_upload_details}}':
 * @property integer $id
 * @property integer $upload_id
 * @property integer $product_category_id
 * @property integer $region_id
 * @property string $gmc
 * @property string $distributer_name
 * @property integer $ot_month
 * @property string $ot_year
 * @property integer $product_id
 * @property integer $distributor_id
 * @property integer $quantity
 * @property string $amount
 */
class OtReportGlobalUploadDetails extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{ot_report_global_upload_details}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('upload_id, product_category_id, region_id, gmc, distributer_name, ot_month, ot_year, product_id, distributor_id', 'required'),
			array('upload_id, product_category_id, region_id, ot_month, product_id, distributor_id, quantity', 'numerical', 'integerOnly'=>true),
			array('gmc, distributer_name', 'length', 'max'=>255),
			array('amount', 'length', 'max'=>15),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, upload_id, product_category_id, region_id, gmc, distributer_name, ot_month, ot_year, product_id, distributor_id, quantity, amount', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'upload_id' => 'Upload',
			'product_category_id' => 'Product Category',
			'region_id' => 'Region',
			'gmc' => 'Gmc',
			'distributer_name' => 'Distributer Name',
			'ot_month' => 'Ot Month',
			'ot_year' => 'Ot Year',
			'product_id' => 'Product',
			'distributor_id' => 'Distributer',
			'quantity' => 'Quantity',
			'amount' => 'Amount',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('upload_id',$this->upload_id);
		$criteria->compare('product_category_id',$this->product_category_id);
		$criteria->compare('region_id',$this->region_id);
		$criteria->compare('gmc',$this->gmc,true);
		$criteria->compare('distributer_name',$this->distributer_name,true);
		$criteria->compare('ot_month',$this->ot_month);
		$criteria->compare('ot_year',$this->ot_year,true);
		$criteria->compare('product_id',$this->product_id);
		$criteria->compare('distributor_id',$this->distributor_id);
		$criteria->compare('quantity',$this->quantity);
		$criteria->compare('amount',$this->amount,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return OtReportGlobalUploadDetails the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
