<?php

$cs = Yii::app()->getClientScript();

$baseUrl = Yii::app()->baseUrl;



$cs->registerScript("loadInventory", '

        $(document).ready(function() {



        var table_id ="#tbl_inventory_details";

        var table = $(table_id).DataTable({

            scrollY         : "380px",

           // scrollX         : "true",

           // scrollCollapse  : true,

            pageLength      : 50,

			processing: true,

            ajax: {

                url: "' . Yii::app()->createUrl('Inventory/GetList') . '",

                type: "POST",

                cache : false,

                "data": function ( params ) {

                    params.YII_CSRF_TOKEN = "' . Yii::app()->request->csrfToken . '";

                }

            },

            serverSide:     true,

            fixedColumns:   true,

			processing: true,

            fixedHeader: {

                headerOffset: $("header.main").outerHeight()

            }

        } );

        $(".dataTables_scrollFoot").hide();

    });', CClientScript::POS_HEAD);

?>

<section class="panel">

    <header class="panel-heading clearfix panel-theame">

        <i class="fa fa-tasks"></i> GMC

        <div class="pull-right">

            <?php if (isset(Yii::app()->user->havePermissionOn['master_gmc_uploadprice']) ||  Yii::app()->user->authorised_user == 1) { ?>

            <button class="btn btn-sm btn-theme" onclick="loadPopupModal('gmcpriceupload/uploadGMCPrice', 'Upload GMC Price', 'lg')"><i class="fa fa-arrow-up"></i> Upload Price</button>

            <?php }  ?>

            <?php if (isset(Yii::app()->user->havePermissionOn['master_gmc_uploadgoodsin']) ||  Yii::app()->user->authorised_user == 1) { ?>

            <button class="btn btn-sm btn-theme" onclick="loadPopupModal('gmcgoodsinupload/uploadGMCGoodsIn', 'Upload GMC Goods In', 'lg')"><i class="fa fa-arrow-up"></i> Upload Goods In Month&Year</button>

            <?php }  ?>

            <?php if (isset(Yii::app()->user->havePermissionOn['master_gmc_upload']) ||  Yii::app()->user->authorised_user == 1) { ?>

            <button class="btn btn-sm btn-theme" onclick="loadPopupModal('gmcupload/uploadGMC', 'Upload GMC', 'lg')"><i class="fa fa-arrow-up"></i> Upload GMC</button>
            <button class="btn btn-sm btn-theme" onclick="loadPopupModal('gmcupload/uploadNewGMC', 'Upload GMC', 'lg')"><i class="fa fa-arrow-up"></i> Upload New GMC</button>

            <?php }  ?>

            <?php if (isset(Yii::app()->user->havePermissionOn['master_gmc_add']) ||  Yii::app()->user->authorised_user == 1) { ?>

            <button class="btn btn-sm btn-theme" onclick="loadPopupModal('inventory/create', 'Add New GMC', 'xl')"><i class="fa fa-plus"></i> ADD</button>

           <?php }  ?>

        </div>



    </header>

    <div class="panel-body">

        <div class="custom-data-table">

            <table class="table table-hover table-bordered personal-task" id="tbl_inventory_details">

                <thead>

                    <tr>

                        <th width="5%">Sl No</th>

                        <th>Category</th>

                        <th>GMC Code</th>

                        <th>Model</th>

                        <th>Base Code</th>

                        <th width="5%">Sort Order</th>

                        <th>Actions</th>

                    </tr>

                </thead>

                <tfoot>

                    <tr>

                        <th width="5%">Sl No</th>

                        <th>Category</th>

                        <th>GMC Code</th>

                        <th>Model</th>

                        <th>Base Code</th>

                        <th width="5%">Sort Order</th>

                        <th>Actions</th>

                    </tr>

                </tfoot>

            </table>

        </div>

    </div>

</section>

<script>

    function discontinuegmc(id) {

        var r = confirm('Are you sure to discontinue this?');

        if (r) {

            loadPopupModal('inventory/discontinue&id=' + id, 'Discontinue GMC', 'lg');



        }

    }

</script>

<script>

    function avoiddiscontinuegmc(id) {

        var r = confirm('Are you sure to avoid discontinuation this?');

        if (r) {

            loadPopupModal('inventory/avoiddiscontinue&id=' + id, 'Avoid Discontinuation GMC', 'lg');



        }

    }

</script>